code
proc StringToFilter 160 8
file "../../../code/game/g_svcmds.c"
line 79
;1:/*
;2:===========================================================================
;3:Copyright (C) 1999-2005 Id Software, Inc.
;4:
;5:This file is part of Quake III Arena source code.
;6:
;7:Quake III Arena source code is free software; you can redistribute it
;8:and/or modify it under the terms of the GNU General Public License as
;9:published by the Free Software Foundation; either version 2 of the License,
;10:or (at your option) any later version.
;11:
;12:Quake III Arena source code is distributed in the hope that it will be
;13:useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
;14:MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;15:GNU General Public License for more details.
;16:
;17:You should have received a copy of the GNU General Public License
;18:along with Quake III Arena source code; if not, write to the Free Software
;19:Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
;20:===========================================================================
;21:*/
;22://
;23:
;24:// this file holds commands that can be executed by the server console, but not remote clients
;25:
;26:#include "g_local.h"
;27:
;28:
;29:/*
;30:==============================================================================
;31:
;32:PACKET FILTERING
;33: 
;34:
;35:You can add or remove addresses from the filter list with:
;36:
;37:addip <ip>
;38:removeip <ip>
;39:
;40:The ip address is specified in dot format, and you can use '*' to match any value
;41:so you can specify an entire class C network with "addip 192.246.40.*"
;42:
;43:Removeip will only remove an address specified exactly the same way.  You cannot addip a subnet, then removeip a single host.
;44:
;45:listip
;46:Prints the current list of filters.
;47:
;48:g_filterban <0 or 1>
;49:
;50:If 1 (the default), then ip addresses matching the current list will be prohibited from entering the game.  This is the default setting.
;51:
;52:If 0, then only addresses matching the list will be allowed.  This lets you easily set up a private game, or a game that only allows players from your local network.
;53:
;54:TTimo NOTE: for persistence, bans are stored in g_banIPs cvar MAX_CVAR_VALUE_STRING
;55:The size of the cvar string buffer is limiting the banning to around 20 masks
;56:this could be improved by putting some g_banIPs2 g_banIps3 etc. maybe
;57:still, you should rely on PB for banning instead
;58:
;59:==============================================================================
;60:*/
;61:
;62:typedef struct ipFilter_s
;63:{
;64:	unsigned	mask;
;65:	unsigned	compare;
;66:} ipFilter_t;
;67:
;68:#define	MAX_IPFILTERS	1024
;69:
;70:static ipFilter_t	ipFilters[MAX_IPFILTERS];
;71:static int			numIPFilters;
;72:
;73:/*
;74:=================
;75:StringToFilter
;76:=================
;77:*/
;78:static qboolean StringToFilter (char *s, ipFilter_t *f)
;79:{
line 85
;80:	char	num[128];
;81:	int		i, j;
;82:	byte	b[4];
;83:	byte	m[4];
;84:	
;85:	for (i=0 ; i<4 ; i++)
ADDRLP4 132
CNSTI4 0
ASGNI4
LABELV $63
line 86
;86:	{
line 87
;87:		b[i] = 0;
ADDRLP4 132
INDIRI4
ADDRLP4 136
ADDP4
CNSTU1 0
ASGNU1
line 88
;88:		m[i] = 0;
ADDRLP4 132
INDIRI4
ADDRLP4 140
ADDP4
CNSTU1 0
ASGNU1
line 89
;89:	}
LABELV $64
line 85
ADDRLP4 132
ADDRLP4 132
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
ADDRLP4 132
INDIRI4
CNSTI4 4
LTI4 $63
line 91
;90:	
;91:	for (i=0 ; i<4 ; i++)
ADDRLP4 132
CNSTI4 0
ASGNI4
LABELV $67
line 92
;92:	{
line 93
;93:		if (*s < '0' || *s > '9')
ADDRLP4 144
ADDRFP4 0
INDIRP4
INDIRI1
CVII4 1
ASGNI4
ADDRLP4 144
INDIRI4
CNSTI4 48
LTI4 $73
ADDRLP4 144
INDIRI4
CNSTI4 57
LEI4 $71
LABELV $73
line 94
;94:		{
line 95
;95:			if (*s == '*') // 'match any'
ADDRFP4 0
INDIRP4
INDIRI1
CVII4 1
CNSTI4 42
NEI4 $74
line 96
;96:			{
line 98
;97:				// b[i] and m[i] to 0
;98:				s++;
ADDRFP4 0
ADDRFP4 0
INDIRP4
CNSTI4 1
ADDP4
ASGNP4
line 99
;99:				if (!*s)
ADDRFP4 0
INDIRP4
INDIRI1
CVII4 1
CNSTI4 0
NEI4 $76
line 100
;100:					break;
ADDRGP4 $69
JUMPV
LABELV $76
line 101
;101:				s++;
ADDRFP4 0
ADDRFP4 0
INDIRP4
CNSTI4 1
ADDP4
ASGNP4
line 102
;102:				continue;
ADDRGP4 $68
JUMPV
LABELV $74
line 104
;103:			}
;104:                        G_Printf( "Bad filter address: %s\n", s );
ADDRGP4 $78
ARGP4
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 105
;105:			return qfalse;
CNSTI4 0
RETI4
ADDRGP4 $62
JUMPV
LABELV $71
line 108
;106:		}
;107:		
;108:		j = 0;
ADDRLP4 128
CNSTI4 0
ASGNI4
ADDRGP4 $80
JUMPV
LABELV $79
line 110
;109:		while (*s >= '0' && *s <= '9')
;110:		{
line 111
;111:			num[j++] = *s++;
ADDRLP4 148
ADDRLP4 128
INDIRI4
ASGNI4
ADDRLP4 156
CNSTI4 1
ASGNI4
ADDRLP4 128
ADDRLP4 148
INDIRI4
ADDRLP4 156
INDIRI4
ADDI4
ASGNI4
ADDRLP4 152
ADDRFP4 0
INDIRP4
ASGNP4
ADDRFP4 0
ADDRLP4 152
INDIRP4
ADDRLP4 156
INDIRI4
ADDP4
ASGNP4
ADDRLP4 148
INDIRI4
ADDRLP4 0
ADDP4
ADDRLP4 152
INDIRP4
INDIRI1
ASGNI1
line 112
;112:		}
LABELV $80
line 109
ADDRLP4 148
ADDRFP4 0
INDIRP4
INDIRI1
CVII4 1
ASGNI4
ADDRLP4 148
INDIRI4
CNSTI4 48
LTI4 $82
ADDRLP4 148
INDIRI4
CNSTI4 57
LEI4 $79
LABELV $82
line 113
;113:		num[j] = 0;
ADDRLP4 128
INDIRI4
ADDRLP4 0
ADDP4
CNSTI1 0
ASGNI1
line 114
;114:		b[i] = atoi(num);
ADDRLP4 0
ARGP4
ADDRLP4 152
ADDRGP4 atoi
CALLI4
ASGNI4
ADDRLP4 132
INDIRI4
ADDRLP4 136
ADDP4
ADDRLP4 152
INDIRI4
CVIU4 4
CVUU1 4
ASGNU1
line 115
;115:		m[i] = 255;
ADDRLP4 132
INDIRI4
ADDRLP4 140
ADDP4
CNSTU1 255
ASGNU1
line 117
;116:
;117:		if (!*s)
ADDRFP4 0
INDIRP4
INDIRI1
CVII4 1
CNSTI4 0
NEI4 $83
line 118
;118:			break;
ADDRGP4 $69
JUMPV
LABELV $83
line 119
;119:		s++;
ADDRFP4 0
ADDRFP4 0
INDIRP4
CNSTI4 1
ADDP4
ASGNP4
line 120
;120:	}
LABELV $68
line 91
ADDRLP4 132
ADDRLP4 132
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
ADDRLP4 132
INDIRI4
CNSTI4 4
LTI4 $67
LABELV $69
line 122
;121:	
;122:	f->mask = *(unsigned *)m;
ADDRFP4 4
INDIRP4
ADDRLP4 140
INDIRU4
ASGNU4
line 123
;123:	f->compare = *(unsigned *)b;
ADDRFP4 4
INDIRP4
CNSTI4 4
ADDP4
ADDRLP4 136
INDIRU4
ASGNU4
line 125
;124:	
;125:	return qtrue;
CNSTI4 1
RETI4
LABELV $62
endproc StringToFilter 160 8
proc UpdateIPBans 344 12
line 134
;126:}
;127:
;128:/*
;129:=================
;130:UpdateIPBans
;131:=================
;132:*/
;133:static void UpdateIPBans (void)
;134:{
line 141
;135:	byte	b[4];
;136:	byte	m[4];
;137:	int		i,j;
;138:	char	iplist_final[MAX_CVAR_VALUE_STRING];
;139:	char	ip[64];
;140:
;141:	*iplist_final = 0;
ADDRLP4 80
CNSTI1 0
ASGNI1
line 142
;142:	for (i = 0 ; i < numIPFilters ; i++)
ADDRLP4 76
CNSTI4 0
ASGNI4
ADDRGP4 $89
JUMPV
LABELV $86
line 143
;143:	{
line 144
;144:		if (ipFilters[i].compare == 0xffffffff)
ADDRLP4 76
INDIRI4
CNSTI4 3
LSHI4
ADDRGP4 ipFilters+4
ADDP4
INDIRU4
CNSTU4 4294967295
NEU4 $90
line 145
;145:			continue;
ADDRGP4 $87
JUMPV
LABELV $90
line 147
;146:
;147:		*(unsigned *)b = ipFilters[i].compare;
ADDRLP4 72
ADDRLP4 76
INDIRI4
CNSTI4 3
LSHI4
ADDRGP4 ipFilters+4
ADDP4
INDIRU4
ASGNU4
line 148
;148:		*(unsigned *)m = ipFilters[i].mask;
ADDRLP4 68
ADDRLP4 76
INDIRI4
CNSTI4 3
LSHI4
ADDRGP4 ipFilters
ADDP4
INDIRU4
ASGNU4
line 149
;149:		*ip = 0;
ADDRLP4 4
CNSTI1 0
ASGNI1
line 150
;150:		for (j = 0 ; j < 4 ; j++)
ADDRLP4 0
CNSTI4 0
ASGNI4
LABELV $94
line 151
;151:		{
line 152
;152:			if (m[j]!=255)
ADDRLP4 0
INDIRI4
ADDRLP4 68
ADDP4
INDIRU1
CVUI4 1
CNSTI4 255
EQI4 $98
line 153
;153:				Q_strcat(ip, sizeof(ip), "*");
ADDRLP4 4
ARGP4
CNSTI4 64
ARGI4
ADDRGP4 $100
ARGP4
ADDRGP4 Q_strcat
CALLV
pop
ADDRGP4 $99
JUMPV
LABELV $98
line 155
;154:			else
;155:				Q_strcat(ip, sizeof(ip), va("%i", b[j]));
ADDRGP4 $101
ARGP4
ADDRLP4 0
INDIRI4
ADDRLP4 72
ADDP4
INDIRU1
CVUI4 1
ARGI4
ADDRLP4 336
ADDRGP4 va
CALLP4
ASGNP4
ADDRLP4 4
ARGP4
CNSTI4 64
ARGI4
ADDRLP4 336
INDIRP4
ARGP4
ADDRGP4 Q_strcat
CALLV
pop
LABELV $99
line 156
;156:			Q_strcat(ip, sizeof(ip), (j<3) ? "." : " ");
ADDRLP4 4
ARGP4
CNSTI4 64
ARGI4
ADDRLP4 0
INDIRI4
CNSTI4 3
GEI4 $105
ADDRLP4 340
ADDRGP4 $102
ASGNP4
ADDRGP4 $106
JUMPV
LABELV $105
ADDRLP4 340
ADDRGP4 $103
ASGNP4
LABELV $106
ADDRLP4 340
INDIRP4
ARGP4
ADDRGP4 Q_strcat
CALLV
pop
line 157
;157:		}		
LABELV $95
line 150
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
ADDRLP4 0
INDIRI4
CNSTI4 4
LTI4 $94
line 158
;158:		if (strlen(iplist_final)+strlen(ip) < MAX_CVAR_VALUE_STRING)
ADDRLP4 80
ARGP4
ADDRLP4 336
ADDRGP4 strlen
CALLI4
ASGNI4
ADDRLP4 4
ARGP4
ADDRLP4 340
ADDRGP4 strlen
CALLI4
ASGNI4
ADDRLP4 336
INDIRI4
ADDRLP4 340
INDIRI4
ADDI4
CNSTI4 256
GEI4 $107
line 159
;159:		{
line 160
;160:			Q_strcat( iplist_final, sizeof(iplist_final), ip);
ADDRLP4 80
ARGP4
CNSTI4 256
ARGI4
ADDRLP4 4
ARGP4
ADDRGP4 Q_strcat
CALLV
pop
line 161
;161:		}
ADDRGP4 $108
JUMPV
LABELV $107
line 163
;162:		else
;163:		{
line 164
;164:			Com_Printf("g_banIPs overflowed at MAX_CVAR_VALUE_STRING\n");
ADDRGP4 $109
ARGP4
ADDRGP4 Com_Printf
CALLV
pop
line 165
;165:			break;
ADDRGP4 $88
JUMPV
LABELV $108
line 167
;166:		}
;167:	}
LABELV $87
line 142
ADDRLP4 76
ADDRLP4 76
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $89
ADDRLP4 76
INDIRI4
ADDRGP4 numIPFilters
INDIRI4
LTI4 $86
LABELV $88
line 169
;168:
;169:	trap_Cvar_Set( "g_banIPs", iplist_final );
ADDRGP4 $110
ARGP4
ADDRLP4 80
ARGP4
ADDRGP4 trap_Cvar_Set
CALLV
pop
line 170
;170:}
LABELV $85
endproc UpdateIPBans 344 12
export G_FilterPacket
proc G_FilterPacket 28 0
line 178
;171:
;172:/*
;173:=================
;174:G_FilterPacket
;175:=================
;176:*/
;177:qboolean G_FilterPacket (char *from)
;178:{
line 184
;179:	int		i;
;180:	unsigned	in;
;181:	byte m[4];
;182:	char *p;
;183:
;184:	i = 0;
ADDRLP4 4
CNSTI4 0
ASGNI4
line 185
;185:	p = from;
ADDRLP4 0
ADDRFP4 0
INDIRP4
ASGNP4
ADDRGP4 $113
JUMPV
LABELV $112
line 186
;186:	while (*p && i < 4) {
line 187
;187:		m[i] = 0;
ADDRLP4 4
INDIRI4
ADDRLP4 8
ADDP4
CNSTU1 0
ASGNU1
ADDRGP4 $116
JUMPV
LABELV $115
line 188
;188:		while (*p >= '0' && *p <= '9') {
line 189
;189:			m[i] = m[i]*10 + (*p - '0');
ADDRLP4 16
ADDRLP4 4
INDIRI4
ADDRLP4 8
ADDP4
ASGNP4
ADDRLP4 16
INDIRP4
CNSTI4 10
ADDRLP4 16
INDIRP4
INDIRU1
CVUI4 1
MULI4
ADDRLP4 0
INDIRP4
INDIRI1
CVII4 1
CNSTI4 48
SUBI4
ADDI4
CVIU4 4
CVUU1 4
ASGNU1
line 190
;190:			p++;
ADDRLP4 0
ADDRLP4 0
INDIRP4
CNSTI4 1
ADDP4
ASGNP4
line 191
;191:		}
LABELV $116
line 188
ADDRLP4 16
ADDRLP4 0
INDIRP4
INDIRI1
CVII4 1
ASGNI4
ADDRLP4 16
INDIRI4
CNSTI4 48
LTI4 $118
ADDRLP4 16
INDIRI4
CNSTI4 57
LEI4 $115
LABELV $118
line 192
;192:		if (!*p || *p == ':')
ADDRLP4 20
ADDRLP4 0
INDIRP4
INDIRI1
CVII4 1
ASGNI4
ADDRLP4 20
INDIRI4
CNSTI4 0
EQI4 $121
ADDRLP4 20
INDIRI4
CNSTI4 58
NEI4 $119
LABELV $121
line 193
;193:			break;
ADDRGP4 $114
JUMPV
LABELV $119
line 194
;194:		i++, p++;
ADDRLP4 24
CNSTI4 1
ASGNI4
ADDRLP4 4
ADDRLP4 4
INDIRI4
ADDRLP4 24
INDIRI4
ADDI4
ASGNI4
ADDRLP4 0
ADDRLP4 0
INDIRP4
ADDRLP4 24
INDIRI4
ADDP4
ASGNP4
line 195
;195:	}
LABELV $113
line 186
ADDRLP4 0
INDIRP4
INDIRI1
CVII4 1
CNSTI4 0
EQI4 $122
ADDRLP4 4
INDIRI4
CNSTI4 4
LTI4 $112
LABELV $122
LABELV $114
line 197
;196:	
;197:	in = *(unsigned *)m;
ADDRLP4 12
ADDRLP4 8
INDIRU4
ASGNU4
line 199
;198:
;199:	for (i=0 ; i<numIPFilters ; i++)
ADDRLP4 4
CNSTI4 0
ASGNI4
ADDRGP4 $126
JUMPV
LABELV $123
line 200
;200:		if ( (in & ipFilters[i].mask) == ipFilters[i].compare)
ADDRLP4 16
ADDRLP4 4
INDIRI4
CNSTI4 3
LSHI4
ASGNI4
ADDRLP4 12
INDIRU4
ADDRLP4 16
INDIRI4
ADDRGP4 ipFilters
ADDP4
INDIRU4
BANDU4
ADDRLP4 16
INDIRI4
ADDRGP4 ipFilters+4
ADDP4
INDIRU4
NEU4 $127
line 201
;201:			return g_filterBan.integer != 0;
ADDRGP4 g_filterBan+12
INDIRI4
CNSTI4 0
EQI4 $132
ADDRLP4 20
CNSTI4 1
ASGNI4
ADDRGP4 $133
JUMPV
LABELV $132
ADDRLP4 20
CNSTI4 0
ASGNI4
LABELV $133
ADDRLP4 20
INDIRI4
RETI4
ADDRGP4 $111
JUMPV
LABELV $127
LABELV $124
line 199
ADDRLP4 4
ADDRLP4 4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $126
ADDRLP4 4
INDIRI4
ADDRGP4 numIPFilters
INDIRI4
LTI4 $123
line 203
;202:
;203:	return g_filterBan.integer == 0;
ADDRGP4 g_filterBan+12
INDIRI4
CNSTI4 0
NEI4 $136
ADDRLP4 24
CNSTI4 1
ASGNI4
ADDRGP4 $137
JUMPV
LABELV $136
ADDRLP4 24
CNSTI4 0
ASGNI4
LABELV $137
ADDRLP4 24
INDIRI4
RETI4
LABELV $111
endproc G_FilterPacket 28 0
proc AddIP 8 8
line 212
;204:}
;205:
;206:/*
;207:=================
;208:AddIP
;209:=================
;210:*/
;211:static void AddIP( char *str )
;212:{
line 215
;213:	int		i;
;214:
;215:	for (i = 0 ; i < numIPFilters ; i++)
ADDRLP4 0
CNSTI4 0
ASGNI4
ADDRGP4 $142
JUMPV
LABELV $139
line 216
;216:		if (ipFilters[i].compare == 0xffffffff)
ADDRLP4 0
INDIRI4
CNSTI4 3
LSHI4
ADDRGP4 ipFilters+4
ADDP4
INDIRU4
CNSTU4 4294967295
NEU4 $143
line 217
;217:			break;		// free spot
ADDRGP4 $141
JUMPV
LABELV $143
LABELV $140
line 215
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $142
ADDRLP4 0
INDIRI4
ADDRGP4 numIPFilters
INDIRI4
LTI4 $139
LABELV $141
line 218
;218:	if (i == numIPFilters)
ADDRLP4 0
INDIRI4
ADDRGP4 numIPFilters
INDIRI4
NEI4 $146
line 219
;219:	{
line 220
;220:		if (numIPFilters == MAX_IPFILTERS)
ADDRGP4 numIPFilters
INDIRI4
CNSTI4 1024
NEI4 $148
line 221
;221:		{
line 222
;222:                        G_Printf ("IP filter list is full\n");
ADDRGP4 $150
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 223
;223:			return;
ADDRGP4 $138
JUMPV
LABELV $148
line 225
;224:		}
;225:		numIPFilters++;
ADDRLP4 4
ADDRGP4 numIPFilters
ASGNP4
ADDRLP4 4
INDIRP4
ADDRLP4 4
INDIRP4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
line 226
;226:	}
LABELV $146
line 228
;227:	
;228:	if (!StringToFilter (str, &ipFilters[i]))
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 0
INDIRI4
CNSTI4 3
LSHI4
ADDRGP4 ipFilters
ADDP4
ARGP4
ADDRLP4 4
ADDRGP4 StringToFilter
CALLI4
ASGNI4
ADDRLP4 4
INDIRI4
CNSTI4 0
NEI4 $151
line 229
;229:		ipFilters[i].compare = 0xffffffffu;
ADDRLP4 0
INDIRI4
CNSTI4 3
LSHI4
ADDRGP4 ipFilters+4
ADDP4
CNSTU4 4294967295
ASGNU4
LABELV $151
line 231
;230:
;231:	UpdateIPBans();
ADDRGP4 UpdateIPBans
CALLV
pop
line 232
;232:}
LABELV $138
endproc AddIP 8 8
export G_ProcessIPBans
proc G_ProcessIPBans 276 12
line 240
;233:
;234:/*
;235:=================
;236:G_ProcessIPBans
;237:=================
;238:*/
;239:void G_ProcessIPBans(void) 
;240:{
line 244
;241:	char *s, *t;
;242:	char		str[MAX_CVAR_VALUE_STRING];
;243:
;244:	Q_strncpyz( str, g_banIPs.string, sizeof(str) );
ADDRLP4 8
ARGP4
ADDRGP4 g_banIPs+16
ARGP4
CNSTI4 256
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 246
;245:
;246:	for (t = s = g_banIPs.string; *t; /* */ ) {
ADDRLP4 264
ADDRGP4 g_banIPs+16
ASGNP4
ADDRLP4 0
ADDRLP4 264
INDIRP4
ASGNP4
ADDRLP4 4
ADDRLP4 264
INDIRP4
ASGNP4
ADDRGP4 $159
JUMPV
LABELV $156
line 247
;247:		s = strchr(s, ' ');
ADDRLP4 0
INDIRP4
ARGP4
CNSTI4 32
ARGI4
ADDRLP4 268
ADDRGP4 strchr
CALLP4
ASGNP4
ADDRLP4 0
ADDRLP4 268
INDIRP4
ASGNP4
line 248
;248:		if (!s)
ADDRLP4 0
INDIRP4
CVPU4 4
CNSTU4 0
NEU4 $164
line 249
;249:			break;
ADDRGP4 $158
JUMPV
LABELV $163
line 251
;250:		while (*s == ' ')
;251:			*s++ = 0;
ADDRLP4 272
ADDRLP4 0
INDIRP4
ASGNP4
ADDRLP4 0
ADDRLP4 272
INDIRP4
CNSTI4 1
ADDP4
ASGNP4
ADDRLP4 272
INDIRP4
CNSTI1 0
ASGNI1
LABELV $164
line 250
ADDRLP4 0
INDIRP4
INDIRI1
CVII4 1
CNSTI4 32
EQI4 $163
line 252
;252:		if (*t)
ADDRLP4 4
INDIRP4
INDIRI1
CVII4 1
CNSTI4 0
EQI4 $166
line 253
;253:			AddIP( t );
ADDRLP4 4
INDIRP4
ARGP4
ADDRGP4 AddIP
CALLV
pop
LABELV $166
line 254
;254:		t = s;
ADDRLP4 4
ADDRLP4 0
INDIRP4
ASGNP4
line 255
;255:	}
LABELV $157
line 246
LABELV $159
ADDRLP4 4
INDIRP4
INDIRI1
CVII4 1
CNSTI4 0
NEI4 $156
LABELV $158
line 256
;256:}
LABELV $154
endproc G_ProcessIPBans 276 12
export Svcmd_AddIP_f
proc Svcmd_AddIP_f 1028 12
line 265
;257:
;258:
;259:/*
;260:=================
;261:Svcmd_AddIP_f
;262:=================
;263:*/
;264:void Svcmd_AddIP_f (void)
;265:{
line 268
;266:	char		str[MAX_TOKEN_CHARS];
;267:
;268:	if ( trap_Argc() < 2 ) {
ADDRLP4 1024
ADDRGP4 trap_Argc
CALLI4
ASGNI4
ADDRLP4 1024
INDIRI4
CNSTI4 2
GEI4 $169
line 269
;269:                G_Printf("Usage:  addip <ip-mask>\n");
ADDRGP4 $171
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 270
;270:		return;
ADDRGP4 $168
JUMPV
LABELV $169
line 273
;271:	}
;272:
;273:	trap_Argv( 1, str, sizeof( str ) );
CNSTI4 1
ARGI4
ADDRLP4 0
ARGP4
CNSTI4 1024
ARGI4
ADDRGP4 trap_Argv
CALLV
pop
line 275
;274:
;275:	AddIP( str );
ADDRLP4 0
ARGP4
ADDRGP4 AddIP
CALLV
pop
line 277
;276:
;277:}
LABELV $168
endproc Svcmd_AddIP_f 1028 12
export Svcmd_RemoveIP_f
proc Svcmd_RemoveIP_f 1048 12
line 285
;278:
;279:/*
;280:=================
;281:Svcmd_RemoveIP_f
;282:=================
;283:*/
;284:void Svcmd_RemoveIP_f (void)
;285:{
line 290
;286:	ipFilter_t	f;
;287:	int			i;
;288:	char		str[MAX_TOKEN_CHARS];
;289:
;290:	if ( trap_Argc() < 2 ) {
ADDRLP4 1036
ADDRGP4 trap_Argc
CALLI4
ASGNI4
ADDRLP4 1036
INDIRI4
CNSTI4 2
GEI4 $173
line 291
;291:                G_Printf("Usage:  sv removeip <ip-mask>\n");
ADDRGP4 $175
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 292
;292:		return;
ADDRGP4 $172
JUMPV
LABELV $173
line 295
;293:	}
;294:
;295:	trap_Argv( 1, str, sizeof( str ) );
CNSTI4 1
ARGI4
ADDRLP4 12
ARGP4
CNSTI4 1024
ARGI4
ADDRGP4 trap_Argv
CALLV
pop
line 297
;296:
;297:	if (!StringToFilter (str, &f))
ADDRLP4 12
ARGP4
ADDRLP4 4
ARGP4
ADDRLP4 1040
ADDRGP4 StringToFilter
CALLI4
ASGNI4
ADDRLP4 1040
INDIRI4
CNSTI4 0
NEI4 $176
line 298
;298:		return;
ADDRGP4 $172
JUMPV
LABELV $176
line 300
;299:
;300:	for (i=0 ; i<numIPFilters ; i++) {
ADDRLP4 0
CNSTI4 0
ASGNI4
ADDRGP4 $181
JUMPV
LABELV $178
line 301
;301:		if (ipFilters[i].mask == f.mask	&&
ADDRLP4 1044
ADDRLP4 0
INDIRI4
CNSTI4 3
LSHI4
ASGNI4
ADDRLP4 1044
INDIRI4
ADDRGP4 ipFilters
ADDP4
INDIRU4
ADDRLP4 4
INDIRU4
NEU4 $182
ADDRLP4 1044
INDIRI4
ADDRGP4 ipFilters+4
ADDP4
INDIRU4
ADDRLP4 4+4
INDIRU4
NEU4 $182
line 302
;302:			ipFilters[i].compare == f.compare) {
line 303
;303:			ipFilters[i].compare = 0xffffffffu;
ADDRLP4 0
INDIRI4
CNSTI4 3
LSHI4
ADDRGP4 ipFilters+4
ADDP4
CNSTU4 4294967295
ASGNU4
line 304
;304:                        G_Printf ("Removed.\n");
ADDRGP4 $187
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 306
;305:
;306:			UpdateIPBans();
ADDRGP4 UpdateIPBans
CALLV
pop
line 307
;307:			return;
ADDRGP4 $172
JUMPV
LABELV $182
line 309
;308:		}
;309:	}
LABELV $179
line 300
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $181
ADDRLP4 0
INDIRI4
ADDRGP4 numIPFilters
INDIRI4
LTI4 $178
line 310
;310:        G_Printf ( "Didn't find %s.\n", str );
ADDRGP4 $188
ARGP4
ADDRLP4 12
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 311
;311:}
LABELV $172
endproc Svcmd_RemoveIP_f 1048 12
export Svcmd_EntityList_f
proc Svcmd_EntityList_f 16 8
line 318
;312:
;313:/*
;314:===================
;315:Svcmd_EntityList_f
;316:===================
;317:*/
;318:void	Svcmd_EntityList_f (void) {
line 322
;319:	int			e;
;320:	gentity_t		*check;
;321:
;322:	check = g_entities+1;
ADDRLP4 0
ADDRGP4 g_entities+816
ASGNP4
line 323
;323:	for (e = 1; e < level.num_entities ; e++, check++) {
ADDRLP4 4
CNSTI4 1
ASGNI4
ADDRGP4 $194
JUMPV
LABELV $191
line 324
;324:		if ( !check->inuse ) {
ADDRLP4 0
INDIRP4
CNSTI4 520
ADDP4
INDIRI4
CNSTI4 0
NEI4 $196
line 325
;325:			continue;
ADDRGP4 $192
JUMPV
LABELV $196
line 327
;326:		}
;327:                G_Printf("%3i:", e);
ADDRGP4 $198
ARGP4
ADDRLP4 4
INDIRI4
ARGI4
ADDRGP4 G_Printf
CALLV
pop
line 328
;328:		switch ( check->s.eType ) {
ADDRLP4 8
ADDRLP4 0
INDIRP4
CNSTI4 4
ADDP4
INDIRI4
ASGNI4
ADDRLP4 8
INDIRI4
CNSTI4 0
LTI4 $199
ADDRLP4 8
INDIRI4
CNSTI4 11
GTI4 $199
ADDRLP4 8
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 $227
ADDP4
INDIRP4
JUMPV
lit
align 4
LABELV $227
address $202
address $204
address $206
address $208
address $210
address $212
address $214
address $216
address $218
address $220
address $222
address $224
code
LABELV $202
line 330
;329:		case ET_GENERAL:
;330:			G_Printf("ET_GENERAL          ");
ADDRGP4 $203
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 331
;331:			break;
ADDRGP4 $200
JUMPV
LABELV $204
line 333
;332:		case ET_PLAYER:
;333:			G_Printf("ET_PLAYER           ");
ADDRGP4 $205
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 334
;334:			break;
ADDRGP4 $200
JUMPV
LABELV $206
line 336
;335:		case ET_ITEM:
;336:			G_Printf("ET_ITEM             ");
ADDRGP4 $207
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 337
;337:			break;
ADDRGP4 $200
JUMPV
LABELV $208
line 339
;338:		case ET_MISSILE:
;339:			G_Printf("ET_MISSILE          ");
ADDRGP4 $209
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 340
;340:			break;
ADDRGP4 $200
JUMPV
LABELV $210
line 342
;341:		case ET_MOVER:
;342:			G_Printf("ET_MOVER            ");
ADDRGP4 $211
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 343
;343:			break;
ADDRGP4 $200
JUMPV
LABELV $212
line 345
;344:		case ET_BEAM:
;345:			G_Printf("ET_BEAM             ");
ADDRGP4 $213
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 346
;346:			break;
ADDRGP4 $200
JUMPV
LABELV $214
line 348
;347:		case ET_PORTAL:
;348:			G_Printf("ET_PORTAL           ");
ADDRGP4 $215
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 349
;349:			break;
ADDRGP4 $200
JUMPV
LABELV $216
line 351
;350:		case ET_SPEAKER:
;351:			G_Printf("ET_SPEAKER          ");
ADDRGP4 $217
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 352
;352:			break;
ADDRGP4 $200
JUMPV
LABELV $218
line 354
;353:		case ET_PUSH_TRIGGER:
;354:			G_Printf("ET_PUSH_TRIGGER     ");
ADDRGP4 $219
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 355
;355:			break;
ADDRGP4 $200
JUMPV
LABELV $220
line 357
;356:		case ET_TELEPORT_TRIGGER:
;357:			G_Printf("ET_TELEPORT_TRIGGER ");
ADDRGP4 $221
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 358
;358:			break;
ADDRGP4 $200
JUMPV
LABELV $222
line 360
;359:		case ET_INVISIBLE:
;360:			G_Printf("ET_INVISIBLE        ");
ADDRGP4 $223
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 361
;361:			break;
ADDRGP4 $200
JUMPV
LABELV $224
line 363
;362:		case ET_GRAPPLE:
;363:			G_Printf("ET_GRAPPLE          ");
ADDRGP4 $225
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 364
;364:			break;
ADDRGP4 $200
JUMPV
LABELV $199
line 366
;365:		default:
;366:			G_Printf("%3i                 ", check->s.eType);
ADDRGP4 $226
ARGP4
ADDRLP4 0
INDIRP4
CNSTI4 4
ADDP4
INDIRI4
ARGI4
ADDRGP4 G_Printf
CALLV
pop
line 367
;367:			break;
LABELV $200
line 369
;368:		}
;369:		if ( check->classname ) {
ADDRLP4 0
INDIRP4
CNSTI4 524
ADDP4
INDIRP4
CVPU4 4
CNSTU4 0
EQU4 $228
line 370
;370:			G_Printf("%s", check->classname);
ADDRGP4 $230
ARGP4
ADDRLP4 0
INDIRP4
CNSTI4 524
ADDP4
INDIRP4
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 371
;371:		}
LABELV $228
line 372
;372:                G_Printf("\n");
ADDRGP4 $231
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 373
;373:	}
LABELV $192
line 323
ADDRLP4 4
ADDRLP4 4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
ADDRLP4 0
ADDRLP4 0
INDIRP4
CNSTI4 816
ADDP4
ASGNP4
LABELV $194
ADDRLP4 4
INDIRI4
ADDRGP4 level+12
INDIRI4
LTI4 $191
line 374
;374:}
LABELV $189
endproc Svcmd_EntityList_f 16 8
export ClientForString
proc ClientForString 24 8
line 376
;375:
;376:gclient_t	*ClientForString( const char *s ) {
line 382
;377:	gclient_t	*cl;
;378:	int			i;
;379:	int			idnum;
;380:
;381:	// numeric values are just slot numbers
;382:	if ( s[0] >= '0' && s[0] <= '9' ) {
ADDRLP4 12
ADDRFP4 0
INDIRP4
INDIRI1
CVII4 1
ASGNI4
ADDRLP4 12
INDIRI4
CNSTI4 48
LTI4 $233
ADDRLP4 12
INDIRI4
CNSTI4 57
GTI4 $233
line 383
;383:		idnum = atoi( s );
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 16
ADDRGP4 atoi
CALLI4
ASGNI4
ADDRLP4 8
ADDRLP4 16
INDIRI4
ASGNI4
line 384
;384:		if ( idnum < 0 || idnum >= level.maxclients ) {
ADDRLP4 20
ADDRLP4 8
INDIRI4
ASGNI4
ADDRLP4 20
INDIRI4
CNSTI4 0
LTI4 $238
ADDRLP4 20
INDIRI4
ADDRGP4 level+24
INDIRI4
LTI4 $235
LABELV $238
line 385
;385:			Com_Printf( "Bad client slot: %i\n", idnum );
ADDRGP4 $239
ARGP4
ADDRLP4 8
INDIRI4
ARGI4
ADDRGP4 Com_Printf
CALLV
pop
line 386
;386:			return NULL;
CNSTP4 0
RETP4
ADDRGP4 $232
JUMPV
LABELV $235
line 389
;387:		}
;388:
;389:		cl = &level.clients[idnum];
ADDRLP4 0
CNSTI4 2116
ADDRLP4 8
INDIRI4
MULI4
ADDRGP4 level
INDIRP4
ADDP4
ASGNP4
line 390
;390:		if ( cl->pers.connected == CON_DISCONNECTED ) {
ADDRLP4 0
INDIRP4
CNSTI4 468
ADDP4
INDIRI4
CNSTI4 0
NEI4 $240
line 391
;391:                        G_Printf( "Client %i is not connected\n", idnum );
ADDRGP4 $242
ARGP4
ADDRLP4 8
INDIRI4
ARGI4
ADDRGP4 G_Printf
CALLV
pop
line 392
;392:			return NULL;
CNSTP4 0
RETP4
ADDRGP4 $232
JUMPV
LABELV $240
line 394
;393:		}
;394:		return cl;
ADDRLP4 0
INDIRP4
RETP4
ADDRGP4 $232
JUMPV
LABELV $233
line 398
;395:	}
;396:
;397:	// check for a name match
;398:	for ( i=0 ; i < level.maxclients ; i++ ) {
ADDRLP4 4
CNSTI4 0
ASGNI4
ADDRGP4 $246
JUMPV
LABELV $243
line 399
;399:		cl = &level.clients[i];
ADDRLP4 0
CNSTI4 2116
ADDRLP4 4
INDIRI4
MULI4
ADDRGP4 level
INDIRP4
ADDP4
ASGNP4
line 400
;400:		if ( cl->pers.connected == CON_DISCONNECTED ) {
ADDRLP4 0
INDIRP4
CNSTI4 468
ADDP4
INDIRI4
CNSTI4 0
NEI4 $248
line 401
;401:			continue;
ADDRGP4 $244
JUMPV
LABELV $248
line 403
;402:		}
;403:		if ( !Q_stricmp( cl->pers.netname, s ) ) {
ADDRLP4 0
INDIRP4
CNSTI4 516
ADDP4
ARGP4
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 16
ADDRGP4 Q_stricmp
CALLI4
ASGNI4
ADDRLP4 16
INDIRI4
CNSTI4 0
NEI4 $250
line 404
;404:			return cl;
ADDRLP4 0
INDIRP4
RETP4
ADDRGP4 $232
JUMPV
LABELV $250
line 406
;405:		}
;406:	}
LABELV $244
line 398
ADDRLP4 4
ADDRLP4 4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $246
ADDRLP4 4
INDIRI4
ADDRGP4 level+24
INDIRI4
LTI4 $243
line 407
;407:        G_Printf( "User %s is not on the server\n", s );
ADDRGP4 $252
ARGP4
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 409
;408:
;409:	return NULL;
CNSTP4 0
RETP4
LABELV $232
endproc ClientForString 24 8
export Svcmd_ForceTeam_f
proc Svcmd_ForceTeam_f 1032 12
line 419
;410:}
;411:
;412:/*
;413:===================
;414:Svcmd_ForceTeam_f
;415:
;416:forceteam <player> <team>
;417:===================
;418:*/
;419:void	Svcmd_ForceTeam_f( void ) {
line 424
;420:	gclient_t	*cl;
;421:	char		str[MAX_TOKEN_CHARS];
;422:
;423:	// find the player
;424:	trap_Argv( 1, str, sizeof( str ) );
CNSTI4 1
ARGI4
ADDRLP4 0
ARGP4
CNSTI4 1024
ARGI4
ADDRGP4 trap_Argv
CALLV
pop
line 425
;425:	cl = ClientForString( str );
ADDRLP4 0
ARGP4
ADDRLP4 1028
ADDRGP4 ClientForString
CALLP4
ASGNP4
ADDRLP4 1024
ADDRLP4 1028
INDIRP4
ASGNP4
line 426
;426:	if ( !cl ) {
ADDRLP4 1024
INDIRP4
CVPU4 4
CNSTU4 0
NEU4 $254
line 427
;427:		return;
ADDRGP4 $253
JUMPV
LABELV $254
line 431
;428:	}
;429:
;430:	// set the team
;431:	trap_Argv( 2, str, sizeof( str ) );
CNSTI4 2
ARGI4
ADDRLP4 0
ARGP4
CNSTI4 1024
ARGI4
ADDRGP4 trap_Argv
CALLV
pop
line 432
;432:	SetTeam( &g_entities[cl - level.clients], str );
CNSTI4 816
ADDRLP4 1024
INDIRP4
CVPU4 4
ADDRGP4 level
INDIRP4
CVPU4 4
SUBU4
CVUI4 4
CNSTI4 2116
DIVI4
MULI4
ADDRGP4 g_entities
ADDP4
ARGP4
ADDRLP4 0
ARGP4
ADDRGP4 SetTeam
CALLV
pop
line 433
;433:}
LABELV $253
endproc Svcmd_ForceTeam_f 1032 12
export ClientKick_f
proc ClientKick_f 1040 12
line 435
;434:
;435:void	ClientKick_f( void ) {
line 439
;436:        int idnum, i;
;437:        char	str[MAX_TOKEN_CHARS];
;438:
;439:        trap_Argv( 1, str, sizeof( str ) );
CNSTI4 1
ARGI4
ADDRLP4 4
ARGP4
CNSTI4 1024
ARGI4
ADDRGP4 trap_Argv
CALLV
pop
line 441
;440:
;441:        for (i = 0; str[i]; i++) {
ADDRLP4 0
CNSTI4 0
ASGNI4
ADDRGP4 $260
JUMPV
LABELV $257
line 442
;442:		if (str[i] < '0' || str[i] > '9') {
ADDRLP4 1032
ADDRLP4 0
INDIRI4
ADDRLP4 4
ADDP4
INDIRI1
CVII4 1
ASGNI4
ADDRLP4 1032
INDIRI4
CNSTI4 48
LTI4 $263
ADDRLP4 1032
INDIRI4
CNSTI4 57
LEI4 $261
LABELV $263
line 443
;443:                    G_Printf("not a valid client number: \"%s\"\n",str);
ADDRGP4 $264
ARGP4
ADDRLP4 4
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 444
;444:			return;
ADDRGP4 $256
JUMPV
LABELV $261
line 446
;445:		}
;446:	}
LABELV $258
line 441
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $260
ADDRLP4 0
INDIRI4
ADDRLP4 4
ADDP4
INDIRI1
CVII4 1
CNSTI4 0
NEI4 $257
line 448
;447:
;448:        idnum = atoi( str );
ADDRLP4 4
ARGP4
ADDRLP4 1032
ADDRGP4 atoi
CALLI4
ASGNI4
ADDRLP4 1028
ADDRLP4 1032
INDIRI4
ASGNI4
line 451
;449:
;450:        //Local client
;451:        if( !strcmp( level.clients[idnum].pers.ip, "localhost" ) ) {
CNSTI4 2116
ADDRLP4 1028
INDIRI4
MULI4
ADDRGP4 level
INDIRP4
ADDP4
CNSTI4 949
ADDP4
ARGP4
ADDRGP4 $267
ARGP4
ADDRLP4 1036
ADDRGP4 strcmp
CALLI4
ASGNI4
ADDRLP4 1036
INDIRI4
CNSTI4 0
NEI4 $265
line 452
;452:            G_Printf("Kick failed - local player\n");
ADDRGP4 $268
ARGP4
ADDRGP4 G_Printf
CALLV
pop
line 453
;453:            return;
ADDRGP4 $256
JUMPV
LABELV $265
line 459
;454:        }
;455:
;456:        //Now clientkick has been moved into game, but we still need to find the idnum the server expects....
;457:        //FIXME: To fix this, we need a relieble way to generate difference between the server's client number and the game's client numbers
;458:        //FIXME: This should not depend on the engine's clientkick at all
;459:        trap_DropClient( idnum, "was kicked" );
ADDRLP4 1028
INDIRI4
ARGI4
ADDRGP4 $269
ARGP4
ADDRGP4 trap_DropClient
CALLV
pop
line 462
;460:        //trap_SendConsoleCommand( EXEC_INSERT, va("clientkick %d\n", level.clients[idnum].ps.clientNum) );
;461:        
;462:}
LABELV $256
endproc ClientKick_f 1040 12
export EndGame_f
proc EndGame_f 0 0
line 464
;463:
;464:void EndGame_f ( void ) {
line 465
;465:    ExitLevel();
ADDRGP4 ExitLevel
CALLV
pop
line 466
;466:}
LABELV $270
endproc EndGame_f 0 0
data
export svcmds
align 4
LABELV svcmds
address $272
byte 4 0
address Svcmd_EntityList_f
address $273
byte 4 0
address Svcmd_ForceTeam_f
address $274
byte 4 0
address Svcmd_GameMem_f
address $275
byte 4 0
address Svcmd_AddBot_f
address $276
byte 4 0
address Svcmd_BotList_f
address $277
byte 4 0
address Svcmd_AbortPodium_f
address $278
byte 4 0
address Svcmd_AddIP_f
address $279
byte 4 0
address Svcmd_RemoveIP_f
address $280
byte 4 0
address Svcmd_ListIP_f
address $281
byte 4 0
address Svcmd_Status_f
address $282
byte 4 0
address Svcmd_EjectClient_f
address $283
byte 4 0
address Svcmd_DumpUser_f
address $284
byte 4 1
address Svcmd_CenterPrint_f
address $285
byte 4 1
address Svcmd_TeamMessage_f
address $286
byte 4 1
address Svcmd_MessageWrapper
address $287
byte 4 1
address Svcmd_Chat_f
address $288
byte 4 0
address ShuffleTeams
address $289
byte 4 0
address ClientKick_f
address $290
byte 4 0
address EndGame_f
export ConsoleCommand
code
proc ConsoleCommand 1036 12
line 521
;467:
;468://KK-OAX Moved this Declaration to g_local.h
;469://char	*ConcatArgs( int start );
;470:
;471:/*KK-OAX
;472:===============
;473:Server Command Table
;474:Not Worth Listing Elsewhere
;475:================
;476:*/
;477:struct
;478:{
;479:  char      *cmd;
;480:  qboolean  dedicated; //if it has to be entered from a dedicated server or RCON
;481:  void      ( *function )( void );
;482:} svcmds[ ] = {
;483:
;484:  { "entityList", qfalse, Svcmd_EntityList_f },
;485:  { "forceTeam", qfalse, Svcmd_ForceTeam_f },
;486:  { "game_memory", qfalse, Svcmd_GameMem_f },
;487:  { "addbot", qfalse, Svcmd_AddBot_f },
;488:  { "botlist", qfalse, Svcmd_BotList_f }, 
;489:  { "abort_podium", qfalse, Svcmd_AbortPodium_f },
;490:  { "addip", qfalse, Svcmd_AddIP_f },
;491:  { "removeip", qfalse, Svcmd_RemoveIP_f },
;492:  
;493:  //KK-OAX Uses wrapper in g_svccmds_ext.c
;494:  { "listip", qfalse, Svcmd_ListIP_f }, 
;495:  //KK-OAX New
;496:  { "status", qfalse, Svcmd_Status_f },
;497:  { "eject", qfalse, Svcmd_EjectClient_f },
;498:  { "dumpuser", qfalse, Svcmd_DumpUser_f },
;499:  // don't handle communication commands unless dedicated
;500:  { "cp", qtrue, Svcmd_CenterPrint_f },
;501:  { "say_team", qtrue, Svcmd_TeamMessage_f },
;502:  { "say", qtrue, Svcmd_MessageWrapper },
;503:  { "chat", qtrue, Svcmd_Chat_f },
;504:  /*{ "m", qtrue, Svcmd_MessageWrapper },
;505:  { "a", qtrue, Svcmd_MessageWrapper },
;506:  { "bp", qtrue, Svcmd_BannerPrint_f }, */
;507:  //Shuffle the teams
;508:  { "shuffle", qfalse, ShuffleTeams },
;509:  //Kicks a player by number in the game logic rather than the server number
;510:  { "clientkick_game", qfalse, ClientKick_f },
;511:  { "endgamenow", qfalse, EndGame_f },
;512:};
;513:
;514:/*
;515:=================
;516:ConsoleCommand
;517:
;518:=================
;519:*/
;520:qboolean  ConsoleCommand( void )
;521:{
line 525
;522:  char cmd[ MAX_TOKEN_CHARS ];
;523:  int  i;
;524:
;525:  trap_Argv( 0, cmd, sizeof( cmd ) );
CNSTI4 0
ARGI4
ADDRLP4 4
ARGP4
CNSTI4 1024
ARGI4
ADDRGP4 trap_Argv
CALLV
pop
line 527
;526:
;527:  for( i = 0; i < sizeof( svcmds ) / sizeof( svcmds[ 0 ] ); i++ )
ADDRLP4 0
CNSTI4 0
ASGNI4
ADDRGP4 $295
JUMPV
LABELV $292
line 528
;528:  {
line 529
;529:    if( !Q_stricmp( cmd, svcmds[ i ].cmd ) )
ADDRLP4 4
ARGP4
CNSTI4 12
ADDRLP4 0
INDIRI4
MULI4
ADDRGP4 svcmds
ADDP4
INDIRP4
ARGP4
ADDRLP4 1028
ADDRGP4 Q_stricmp
CALLI4
ASGNI4
ADDRLP4 1028
INDIRI4
CNSTI4 0
NEI4 $296
line 530
;530:    {
line 531
;531:      if( svcmds[ i ].dedicated && !g_dedicated.integer )
ADDRLP4 1032
CNSTI4 0
ASGNI4
CNSTI4 12
ADDRLP4 0
INDIRI4
MULI4
ADDRGP4 svcmds+4
ADDP4
INDIRI4
ADDRLP4 1032
INDIRI4
EQI4 $298
ADDRGP4 g_dedicated+12
INDIRI4
ADDRLP4 1032
INDIRI4
NEI4 $298
line 532
;532:        return qfalse;
CNSTI4 0
RETI4
ADDRGP4 $291
JUMPV
LABELV $298
line 533
;533:      svcmds[ i ].function( );
CNSTI4 12
ADDRLP4 0
INDIRI4
MULI4
ADDRGP4 svcmds+8
ADDP4
INDIRP4
CALLV
pop
line 534
;534:      return qtrue;
CNSTI4 1
RETI4
ADDRGP4 $291
JUMPV
LABELV $296
line 536
;535:    }
;536:  }
LABELV $293
line 527
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $295
ADDRLP4 0
INDIRI4
CVIU4 4
CNSTU4 19
LTU4 $292
line 539
;537:  // KK-OAX Will be enabled when admin is added. 
;538:  // see if this is an admin command
;539:  if( G_admin_cmd_check( NULL, qfalse ) )
CNSTP4 0
ARGP4
CNSTI4 0
ARGI4
ADDRLP4 1028
ADDRGP4 G_admin_cmd_check
CALLI4
ASGNI4
ADDRLP4 1028
INDIRI4
CNSTI4 0
EQI4 $303
line 540
;540:    return qtrue;
CNSTI4 1
RETI4
ADDRGP4 $291
JUMPV
LABELV $303
line 542
;541:
;542:  if( g_dedicated.integer )
ADDRGP4 g_dedicated+12
INDIRI4
CNSTI4 0
EQI4 $305
line 543
;543:    G_Printf( "unknown command: %s\n", cmd );
ADDRGP4 $308
ARGP4
ADDRLP4 4
ARGP4
ADDRGP4 G_Printf
CALLV
pop
LABELV $305
line 545
;544:
;545:  return qfalse;
CNSTI4 0
RETI4
LABELV $291
endproc ConsoleCommand 1036 12
bss
align 4
LABELV numIPFilters
skip 4
align 4
LABELV ipFilters
skip 8192
import G_admin_namelog_cleanup
import G_admin_cleanup
import G_admin_duration
import G_admin_buffer_end
import G_admin_buffer_begin
import G_admin_buffer_print
import G_admin_print
import G_admin_shuffle
import G_admin_warn
import G_admin_slap
import G_admin_orient
import G_admin_disorient
import G_admin_unlock
import G_admin_lock
import G_admin_namelog
import G_admin_nextmap
import G_admin_restart
import G_admin_rename
import G_admin_spec999
import G_admin_passvote
import G_admin_cancelvote
import G_admin_allready
import G_admin_admintest
import G_admin_help
import G_admin_showbans
import G_admin_mute
import G_admin_map
import G_admin_listplayers
import G_admin_listadmins
import G_admin_putteam
import G_admin_unban
import G_admin_ban
import G_admin_adjustban
import G_admin_kick
import G_admin_setlevel
import G_admin_time
import G_admin_parse_time
import G_admin_level
import G_admin_namelog_update
import G_admin_name_check
import G_admin_permission
import G_admin_readconfig
import G_admin_cmd_check
import G_admin_ban_check
import G_ConfigClientExcellent
import G_checkForMultiKill
import G_CheckForSpree
import G_RunStreakLogic
import G_ReadAltKillSettings
import Svcmd_MessageWrapper
import Svcmd_ListIP_f
import Svcmd_Chat_f
import Svcmd_DumpUser_f
import Svcmd_EjectClient_f
import Svcmd_BannerPrint_f
import Svcmd_CenterPrint_f
import Svcmd_TeamMessage_f
import Svcmd_Status_f
import trap_DemoCommand
import trap_SnapVector
import trap_GeneticParentsAndChildSelection
import trap_BotResetWeaponState
import trap_BotFreeWeaponState
import trap_BotAllocWeaponState
import trap_BotLoadWeaponWeights
import trap_BotGetWeaponInfo
import trap_BotChooseBestFightWeapon
import trap_BotAddAvoidSpot
import trap_BotInitMoveState
import trap_BotFreeMoveState
import trap_BotAllocMoveState
import trap_BotPredictVisiblePosition
import trap_BotMovementViewTarget
import trap_BotReachabilityArea
import trap_BotResetLastAvoidReach
import trap_BotResetAvoidReach
import trap_BotMoveInDirection
import trap_BotMoveToGoal
import trap_BotResetMoveState
import trap_BotFreeGoalState
import trap_BotAllocGoalState
import trap_BotMutateGoalFuzzyLogic
import trap_BotSaveGoalFuzzyLogic
import trap_BotInterbreedGoalFuzzyLogic
import trap_BotFreeItemWeights
import trap_BotLoadItemWeights
import trap_BotUpdateEntityItems
import trap_BotInitLevelItems
import trap_BotSetAvoidGoalTime
import trap_BotAvoidGoalTime
import trap_BotGetLevelItemGoal
import trap_BotGetMapLocationGoal
import trap_BotGetNextCampSpotGoal
import trap_BotItemGoalInVisButNotVisible
import trap_BotTouchingGoal
import trap_BotChooseNBGItem
import trap_BotChooseLTGItem
import trap_BotGetSecondGoal
import trap_BotGetTopGoal
import trap_BotGoalName
import trap_BotDumpGoalStack
import trap_BotDumpAvoidGoals
import trap_BotEmptyGoalStack
import trap_BotPopGoal
import trap_BotPushGoal
import trap_BotResetAvoidGoals
import trap_BotRemoveFromAvoidGoals
import trap_BotResetGoalState
import trap_BotSetChatName
import trap_BotSetChatGender
import trap_BotLoadChatFile
import trap_BotReplaceSynonyms
import trap_UnifyWhiteSpaces
import trap_BotMatchVariable
import trap_BotFindMatch
import trap_StringContains
import trap_BotGetChatMessage
import trap_BotEnterChat
import trap_BotChatLength
import trap_BotReplyChat
import trap_BotNumInitialChats
import trap_BotInitialChat
import trap_BotNumConsoleMessages
import trap_BotNextConsoleMessage
import trap_BotRemoveConsoleMessage
import trap_BotQueueConsoleMessage
import trap_BotFreeChatState
import trap_BotAllocChatState
import trap_Characteristic_String
import trap_Characteristic_BInteger
import trap_Characteristic_Integer
import trap_Characteristic_BFloat
import trap_Characteristic_Float
import trap_BotFreeCharacter
import trap_BotLoadCharacter
import trap_EA_ResetInput
import trap_EA_GetInput
import trap_EA_EndRegular
import trap_EA_View
import trap_EA_Move
import trap_EA_DelayedJump
import trap_EA_Jump
import trap_EA_SelectWeapon
import trap_EA_MoveRight
import trap_EA_MoveLeft
import trap_EA_MoveBack
import trap_EA_MoveForward
import trap_EA_MoveDown
import trap_EA_MoveUp
import trap_EA_Crouch
import trap_EA_Respawn
import trap_EA_Use
import trap_EA_Attack
import trap_EA_Talk
import trap_EA_Gesture
import trap_EA_Action
import trap_EA_Command
import trap_EA_SayTeam
import trap_EA_Say
import trap_AAS_PredictClientMovement
import trap_AAS_Swimming
import trap_AAS_AlternativeRouteGoals
import trap_AAS_PredictRoute
import trap_AAS_EnableRoutingArea
import trap_AAS_AreaTravelTimeToGoalArea
import trap_AAS_AreaReachability
import trap_AAS_IntForBSPEpairKey
import trap_AAS_FloatForBSPEpairKey
import trap_AAS_VectorForBSPEpairKey
import trap_AAS_ValueForBSPEpairKey
import trap_AAS_NextBSPEntity
import trap_AAS_PointContents
import trap_AAS_TraceAreas
import trap_AAS_PointReachabilityAreaIndex
import trap_AAS_PointAreaNum
import trap_AAS_Time
import trap_AAS_PresenceTypeBoundingBox
import trap_AAS_Initialized
import trap_AAS_EntityInfo
import trap_AAS_AreaInfo
import trap_AAS_BBoxAreas
import trap_BotUserCommand
import trap_BotGetServerCommand
import trap_BotGetSnapshotEntity
import trap_BotLibTest
import trap_BotLibUpdateEntity
import trap_BotLibLoadMap
import trap_BotLibStartFrame
import trap_BotLibDefine
import trap_BotLibVarGet
import trap_BotLibVarSet
import trap_BotLibShutdown
import trap_BotLibSetup
import trap_DebugPolygonDelete
import trap_DebugPolygonCreate
import trap_GetEntityToken
import trap_GetUsercmd
import trap_BotFreeClient
import trap_BotAllocateClient
import trap_EntityContact
import trap_EntitiesInBox
import trap_UnlinkEntity
import trap_LinkEntity
import trap_AreasConnected
import trap_AdjustAreaPortalState
import trap_InPVSIgnorePortals
import trap_InPVS
import trap_PointContents
import trap_Trace
import trap_SetBrushModel
import trap_GetServerinfo
import trap_SetUserinfo
import trap_GetUserinfo
import trap_GetConfigstring
import trap_SetConfigstring
import trap_SendServerCommand
import trap_DropClient
import trap_LocateGameData
import trap_Cvar_VariableStringBuffer
import trap_Cvar_VariableValue
import trap_Cvar_VariableIntegerValue
import trap_Cvar_Set
import trap_Cvar_Update
import trap_Cvar_Register
import trap_SendConsoleCommand
import trap_FS_Seek
import trap_FS_GetFileList
import trap_FS_FCloseFile
import trap_FS_Write
import trap_FS_Read
import trap_FS_FOpenFile
import trap_Args
import trap_Argv
import trap_Argc
import trap_RealTime
import trap_Milliseconds
import trap_Error
import trap_Printf
import g_maxNameChanges
import g_minNameChangePeriod
import g_warningExpire
import g_maxWarnings
import g_publicAdminMessages
import g_specChat
import g_adminMaxBan
import g_adminTempBan
import g_adminNameProtect
import g_adminParseSay
import g_adminLog
import g_admin
import g_floodMinTime
import g_floodMaxDemerits
import g_spreeDiv
import g_altExcellent
import g_sprees
import g_lagLightning
import sv_fps
import g_truePing
import g_delagHitscan
import g_blueTeamClientNumbers
import g_redTeamClientNumbers
import g_humanplayers
import g_maxvotes
import g_voteMaxFraglimit
import g_voteMinFraglimit
import g_voteMaxTimelimit
import g_voteMinTimelimit
import g_voteGametypes
import g_voteBan
import g_voteNames
import g_mappools
import g_autonextmap
import g_catchup
import g_persistantpowerups
import g_awardpushing
import g_elimination_ctf_oneway
import g_lms_mode
import g_lms_lives
import g_ffa_gt
import g_regen
import g_vampireMaxHealth
import g_vampire
import g_instantgib
import g_rockets
import g_elimination_lockspectator
import g_elimination_nail
import g_elimination_mine
import g_elimination_chain
import g_elimination_plasmagun
import g_elimination_lightning
import g_elimination_railgun
import g_elimination_rocket
import g_elimination_grenade
import g_elimination_shotgun
import g_elimination_machinegun
import g_elimination_allgametypes
import g_elimination_activewarmup
import g_elimination_warmup
import g_elimination_roundtime
import g_elimination_grapple
import g_elimination_bfg
import g_elimination_startArmor
import g_elimination_startHealth
import g_elimination_selfdamage
import g_spawnprotect
import g_music
import g_proxMineTimeout
import g_enableBreath
import g_enableDust
import g_rankings
import pmove_float
import pmove_msec
import pmove_fixed
import g_smoothClients
import g_cubeTimeout
import g_obeliskRespawnDelay
import g_obeliskRegenAmount
import g_obeliskRegenPeriod
import g_obeliskHealth
import g_filterBan
import g_banIPs
import g_teamForceBalance
import g_teamAutoJoin
import g_allowVote
import g_blood
import g_doWarmup
import g_warmup
import g_votecustom
import g_votemaps
import g_motdfile
import g_motd
import g_synchronousClients
import g_weaponTeamRespawn
import g_weaponRespawn
import g_debugDamage
import g_debugAlloc
import g_debugMove
import g_inactivity
import g_respawntime
import g_forcerespawn
import g_quadfactor
import g_knockback
import g_speed
import g_gravityModifier
import g_gravity
import g_needpass
import g_password
import g_friendlyFire
import g_capturelimit
import g_timelimit
import g_fraglimit
import g_voteflags
import g_elimflags
import g_videoflags
import g_dmflags
import g_restarted
import g_maxGameClients
import g_maxclients
import g_cheats
import g_dedicated
import g_gametype
import g_entities
import level
import Team_ForceGesture
import Team_DD_bonusAtPoints
import Team_RemoveDoubleDominationPoints
import Team_SpawnDoubleDominationPoints
import Pickup_Team
import CheckTeamStatus
import TeamplayInfoMessage
import Team_GetLocationMsg
import Team_GetLocation
import Team_Dom_SpawnPoints
import SelectDoubleDominationSpawnPoint
import SelectCTFSpawnPoint
import Team_FreeEntity
import Team_ReturnFlag
import Team_InitGame
import Team_CheckHurtCarrier
import Team_FragBonuses
import Team_DroppedFlagThink
import AddTeamScore
import TeamColorString
import OtherTeamName
import TeamName
import OtherTeam
import BotTestAAS
import BotAIStartFrame
import BotAIShutdownClient
import BotAISetupClient
import BotAILoadMap
import BotAIShutdown
import BotAISetup
import getCustomVote
import VoteParseCustomVotes
import allowedFraglimit
import allowedTimelimit
import allowedGametype
import allowedMap
import getMappage
import custom_vote_info
import ClientLeaving
import CountVotes
import CheckVote
import allowedVote
import PlayerStore_restore
import PlayerStore_store
import PlayerStoreInit
import BotInterbreedEndMatch
import Svcmd_BotList_f
import Svcmd_AddBot_f
import G_BotConnect
import G_RemoveQueuedBotBegin
import G_CheckBotSpawn
import G_GetBotInfoByName
import G_GetBotInfoByNumber
import G_InitBots
import Svcmd_AbortPodium_f
import SpawnModelsOnVictoryPads
import UpdateTournamentInfo
import G_WriteSessionData
import G_InitWorldSession
import G_InitSessionData
import G_ReadSessionData
import Svcmd_GameMem_f
import G_TeamFromString
import ShuffleTeams
import CheckObeliskAttack
import Team_CheckDroppedItem
import OnSameTeam
import G_RunClient
import ClientEndFrame
import ClientThink
import ClientCommand
import ClientBegin
import ClientDisconnect
import ClientUserinfoChanged
import ClientConnect
import CheckTeamVote
import LogExit
import G_DemoCommand
import G_Error
import G_Printf
import SendYourTeamMessageToTeam
import SendDominationPointsStatusMessageToAllClients
import SendDDtimetakenMessageToAllClients
import SendEliminationMessageToAllClients
import SendScoreboardMessageToAllClients
import G_LogPrintf
import ExitLevel
import AddTournamentQueue
import G_RunThink
import CheckTeamLeader
import SetLeader
import FindIntermissionPoint
import SendCustomVoteCommands
import ChallengeMessage
import DominationPointStatusMessage
import DominationPointNamesMessage
import RespawnTimeMessage
import EliminationMessage
import DeathmatchScoreboardMessage
import ObeliskHealthMessage
import AttackingTeamMessage
import YourTeamMessage
import DoubleDominationScoreTimeMessage
import G_SetStats
import MoveClientToIntermission
import G_StartKamikaze
import FireWeapon
import SpotWouldTelefrag
import CalculateRanks
import AddScore
import player_die
import ClientSpawn
import InitBodyQue
import InitClientResp
import InitClientPersistant
import BeginIntermission
import respawn
import CopyToBodyQue
import SelectSpawnPoint
import SetClientViewAngle
import PickTeam
import TeamLeader
import LMSpoint
import EndEliminationRound
import DisableWeapons
import EnableWeapons
import RespawnDead
import RespawnAll
import TeamHealthCount
import TeamLivingCount
import TeamCount
import G_PredictPlayerMove
import G_UnTimeShiftClient
import G_UndoTimeShiftFor
import G_DoTimeShiftFor
import G_UnTimeShiftAllClients
import G_TimeShiftAllClients
import G_StoreHistory
import G_ResetHistory
import Weapon_HookThink
import Weapon_HookFree
import CheckGauntletAttack
import SnapVectorTowards
import CalcMuzzlePoint
import LogAccuracyHit
import DropPortalDestination
import DropPortalSource
import TeleportPlayer
import trigger_teleporter_touch
import Touch_DoorTrigger
import G_RunMover
import fire_prox
import fire_nail
import fire_grapple
import fire_bfg
import fire_rocket
import fire_grenade
import fire_plasma
import fire_blaster
import ProximityMine_RemoveAll
import G_RunMissile
import TossClientCubes
import TossClientPersistantPowerups
import TossClientItems
import body_die
import G_InvulnerabilityEffect
import G_RadiusDamage
import G_Damage
import CanDamage
import BuildShaderStateConfig
import AddRemap
import G_SetOrigin
import G_AddEvent
import G_AddPredictableEvent
import vectoyaw
import vtos
import tv
import G_TouchSolids
import G_TouchTriggers
import G_EntitiesFree
import G_FreeEntity
import G_GlobalSound
import G_Sound
import G_TempEntity
import G_Spawn
import G_InitGentity
import G_SetMovedir
import G_UseTargets
import G_PickTarget
import G_Find
import G_KillBox
import G_TeamCommand
import G_SoundIndex
import G_ModelIndex
import SaveRegisteredItems
import RegisterItem
import ClearRegisteredItems
import Touch_Item
import Add_Ammo
import ArmorIndex
import Think_Weapon
import FinishSpawningItem
import G_SpawnItem
import SetRespawn
import LaunchItem
import Drop_Item
import PrecacheItem
import UseHoldableItem
import RespawnItem
import G_RunItem
import G_CheckTeamItems
import writeFile_string
import writeFile_int
import readFile_string
import readFile_int
import SanitizeString
import G_ClientIsLagging
import G_ClientNumberFromString
import Cmd_AdminMessage_f
import G_FloodLimited
import G_ClientNumbersFromString
import G_SanitiseString
import G_MatchOnePlayer
import G_DecolorString
import G_SayConcatArgs
import G_SayArgv
import G_SayArgc
import G_Say
import ConcatArgs
import Cmd_FollowCycle_f
import SetTeam
import BroadcastTeamChange
import StopFollowing
import Cmd_Score_f
import G_NewString
import G_SpawnEntitiesFromString
import G_SpawnVector
import G_SpawnInt
import G_SpawnFloat
import G_SpawnString
import BG_TeamName
import BG_PlayerTouchesItem
import BG_PlayerStateToEntityStateExtraPolate
import BG_PlayerStateToEntityState
import BG_TouchJumpPad
import BG_AddPredictableEventToPlayerstate
import BG_EvaluateTrajectoryDelta
import BG_EvaluateTrajectory
import BG_DefragmentMemory
import BG_Free
import BG_InitMemory
import BG_Alloc
import BG_CanAlloc
import BG_CanItemBeGrabbed
import BG_FindItemForHoldable
import BG_FindItemForPowerup
import BG_FindItemForWeapon
import BG_FindItem
import bg_numItems
import bg_itemlist
import Pmove
import PM_UpdateViewAngles
import Com_Printf
import Com_Error
import Info_NextPair
import Info_Validate
import Info_SetValueForKey_Big
import Info_SetValueForKey
import Info_RemoveKey_big
import Info_RemoveKey
import Info_ValueForKey
import Com_TruncateLongString
import va
import Q_CountChar
import Q_CleanStr
import Q_PrintStrlen
import Q_strcat
import Q_strncpyz
import Q_stristr
import Q_strupr
import Q_strlwr
import Q_stricmpn
import Q_strncmp
import Q_stricmp
import Q_isalpha
import Q_isupper
import Q_islower
import Q_isprint
import Com_RandomBytes
import Com_SkipCharset
import Com_SkipTokens
import Com_sprintf
import Parse3DMatrix
import Parse2DMatrix
import Parse1DMatrix
import SkipRestOfLine
import SkipBracedSection
import COM_MatchToken
import COM_ParseWarning
import COM_ParseError
import COM_Compress
import COM_ParseExt
import COM_Parse
import COM_GetCurrentParseLine
import COM_BeginParseSession
import COM_DefaultExtension
import COM_StripExtension
import COM_GetExtension
import COM_SkipPath
import Com_Clamp
import Q_isnan
import PerpendicularVector
import AngleVectors
import MatrixMultiply
import MakeNormalVectors
import RotateAroundDirection
import RotatePointAroundVector
import ProjectPointOnPlane
import PlaneFromPoints
import AngleDelta
import AngleNormalize180
import AngleNormalize360
import AnglesSubtract
import AngleSubtract
import LerpAngle
import AngleMod
import BoundsIntersectPoint
import BoundsIntersectSphere
import BoundsIntersect
import BoxOnPlaneSide
import SetPlaneSignbits
import AxisCopy
import AxisClear
import AnglesToAxis
import vectoangles
import Q_crandom
import Q_random
import Q_rand
import Q_acos
import Q_log2
import VectorRotate
import Vector4Scale
import VectorNormalize2
import VectorNormalize
import CrossProduct
import VectorInverse
import VectorNormalizeFast
import DistanceSquared
import Distance
import VectorLengthSquared
import VectorLength
import VectorCompare
import AddPointToBounds
import ClearBounds
import RadiusFromBounds
import NormalizeColor
import ColorBytes4
import ColorBytes3
import _VectorMA
import _VectorScale
import _VectorCopy
import _VectorAdd
import _VectorSubtract
import _DotProduct
import ByteToDir
import DirToByte
import ClampShort
import ClampChar
import Q_rsqrt
import Q_fabs
import axisDefault
import vec3_origin
import g_color_table
import colorDkGrey
import colorMdGrey
import colorLtGrey
import colorWhite
import colorCyan
import colorMagenta
import colorYellow
import colorBlue
import colorGreen
import colorRed
import colorBlack
import bytedirs
import Hunk_Alloc
import FloatSwap
import LongSwap
import ShortSwap
import acos
import fabs
import abs
import tan
import atan2
import cos
import sin
import sqrt
import floor
import ceil
import memcpy
import memset
import memmove
import sscanf
import Q_snprintf
import Q_vsnprintf
import strtol
import _atoi
import atoi
import strtod
import _atof
import atof
import toupper
import tolower
import strncpy
import strstr
import strrchr
import strchr
import strcmp
import strcpy
import strcat
import strlen
import rand
import srand
import qsort
lit
align 1
LABELV $308
byte 1 117
byte 1 110
byte 1 107
byte 1 110
byte 1 111
byte 1 119
byte 1 110
byte 1 32
byte 1 99
byte 1 111
byte 1 109
byte 1 109
byte 1 97
byte 1 110
byte 1 100
byte 1 58
byte 1 32
byte 1 37
byte 1 115
byte 1 10
byte 1 0
align 1
LABELV $290
byte 1 101
byte 1 110
byte 1 100
byte 1 103
byte 1 97
byte 1 109
byte 1 101
byte 1 110
byte 1 111
byte 1 119
byte 1 0
align 1
LABELV $289
byte 1 99
byte 1 108
byte 1 105
byte 1 101
byte 1 110
byte 1 116
byte 1 107
byte 1 105
byte 1 99
byte 1 107
byte 1 95
byte 1 103
byte 1 97
byte 1 109
byte 1 101
byte 1 0
align 1
LABELV $288
byte 1 115
byte 1 104
byte 1 117
byte 1 102
byte 1 102
byte 1 108
byte 1 101
byte 1 0
align 1
LABELV $287
byte 1 99
byte 1 104
byte 1 97
byte 1 116
byte 1 0
align 1
LABELV $286
byte 1 115
byte 1 97
byte 1 121
byte 1 0
align 1
LABELV $285
byte 1 115
byte 1 97
byte 1 121
byte 1 95
byte 1 116
byte 1 101
byte 1 97
byte 1 109
byte 1 0
align 1
LABELV $284
byte 1 99
byte 1 112
byte 1 0
align 1
LABELV $283
byte 1 100
byte 1 117
byte 1 109
byte 1 112
byte 1 117
byte 1 115
byte 1 101
byte 1 114
byte 1 0
align 1
LABELV $282
byte 1 101
byte 1 106
byte 1 101
byte 1 99
byte 1 116
byte 1 0
align 1
LABELV $281
byte 1 115
byte 1 116
byte 1 97
byte 1 116
byte 1 117
byte 1 115
byte 1 0
align 1
LABELV $280
byte 1 108
byte 1 105
byte 1 115
byte 1 116
byte 1 105
byte 1 112
byte 1 0
align 1
LABELV $279
byte 1 114
byte 1 101
byte 1 109
byte 1 111
byte 1 118
byte 1 101
byte 1 105
byte 1 112
byte 1 0
align 1
LABELV $278
byte 1 97
byte 1 100
byte 1 100
byte 1 105
byte 1 112
byte 1 0
align 1
LABELV $277
byte 1 97
byte 1 98
byte 1 111
byte 1 114
byte 1 116
byte 1 95
byte 1 112
byte 1 111
byte 1 100
byte 1 105
byte 1 117
byte 1 109
byte 1 0
align 1
LABELV $276
byte 1 98
byte 1 111
byte 1 116
byte 1 108
byte 1 105
byte 1 115
byte 1 116
byte 1 0
align 1
LABELV $275
byte 1 97
byte 1 100
byte 1 100
byte 1 98
byte 1 111
byte 1 116
byte 1 0
align 1
LABELV $274
byte 1 103
byte 1 97
byte 1 109
byte 1 101
byte 1 95
byte 1 109
byte 1 101
byte 1 109
byte 1 111
byte 1 114
byte 1 121
byte 1 0
align 1
LABELV $273
byte 1 102
byte 1 111
byte 1 114
byte 1 99
byte 1 101
byte 1 84
byte 1 101
byte 1 97
byte 1 109
byte 1 0
align 1
LABELV $272
byte 1 101
byte 1 110
byte 1 116
byte 1 105
byte 1 116
byte 1 121
byte 1 76
byte 1 105
byte 1 115
byte 1 116
byte 1 0
align 1
LABELV $269
byte 1 119
byte 1 97
byte 1 115
byte 1 32
byte 1 107
byte 1 105
byte 1 99
byte 1 107
byte 1 101
byte 1 100
byte 1 0
align 1
LABELV $268
byte 1 75
byte 1 105
byte 1 99
byte 1 107
byte 1 32
byte 1 102
byte 1 97
byte 1 105
byte 1 108
byte 1 101
byte 1 100
byte 1 32
byte 1 45
byte 1 32
byte 1 108
byte 1 111
byte 1 99
byte 1 97
byte 1 108
byte 1 32
byte 1 112
byte 1 108
byte 1 97
byte 1 121
byte 1 101
byte 1 114
byte 1 10
byte 1 0
align 1
LABELV $267
byte 1 108
byte 1 111
byte 1 99
byte 1 97
byte 1 108
byte 1 104
byte 1 111
byte 1 115
byte 1 116
byte 1 0
align 1
LABELV $264
byte 1 110
byte 1 111
byte 1 116
byte 1 32
byte 1 97
byte 1 32
byte 1 118
byte 1 97
byte 1 108
byte 1 105
byte 1 100
byte 1 32
byte 1 99
byte 1 108
byte 1 105
byte 1 101
byte 1 110
byte 1 116
byte 1 32
byte 1 110
byte 1 117
byte 1 109
byte 1 98
byte 1 101
byte 1 114
byte 1 58
byte 1 32
byte 1 34
byte 1 37
byte 1 115
byte 1 34
byte 1 10
byte 1 0
align 1
LABELV $252
byte 1 85
byte 1 115
byte 1 101
byte 1 114
byte 1 32
byte 1 37
byte 1 115
byte 1 32
byte 1 105
byte 1 115
byte 1 32
byte 1 110
byte 1 111
byte 1 116
byte 1 32
byte 1 111
byte 1 110
byte 1 32
byte 1 116
byte 1 104
byte 1 101
byte 1 32
byte 1 115
byte 1 101
byte 1 114
byte 1 118
byte 1 101
byte 1 114
byte 1 10
byte 1 0
align 1
LABELV $242
byte 1 67
byte 1 108
byte 1 105
byte 1 101
byte 1 110
byte 1 116
byte 1 32
byte 1 37
byte 1 105
byte 1 32
byte 1 105
byte 1 115
byte 1 32
byte 1 110
byte 1 111
byte 1 116
byte 1 32
byte 1 99
byte 1 111
byte 1 110
byte 1 110
byte 1 101
byte 1 99
byte 1 116
byte 1 101
byte 1 100
byte 1 10
byte 1 0
align 1
LABELV $239
byte 1 66
byte 1 97
byte 1 100
byte 1 32
byte 1 99
byte 1 108
byte 1 105
byte 1 101
byte 1 110
byte 1 116
byte 1 32
byte 1 115
byte 1 108
byte 1 111
byte 1 116
byte 1 58
byte 1 32
byte 1 37
byte 1 105
byte 1 10
byte 1 0
align 1
LABELV $231
byte 1 10
byte 1 0
align 1
LABELV $230
byte 1 37
byte 1 115
byte 1 0
align 1
LABELV $226
byte 1 37
byte 1 51
byte 1 105
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 0
align 1
LABELV $225
byte 1 69
byte 1 84
byte 1 95
byte 1 71
byte 1 82
byte 1 65
byte 1 80
byte 1 80
byte 1 76
byte 1 69
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 0
align 1
LABELV $223
byte 1 69
byte 1 84
byte 1 95
byte 1 73
byte 1 78
byte 1 86
byte 1 73
byte 1 83
byte 1 73
byte 1 66
byte 1 76
byte 1 69
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 0
align 1
LABELV $221
byte 1 69
byte 1 84
byte 1 95
byte 1 84
byte 1 69
byte 1 76
byte 1 69
byte 1 80
byte 1 79
byte 1 82
byte 1 84
byte 1 95
byte 1 84
byte 1 82
byte 1 73
byte 1 71
byte 1 71
byte 1 69
byte 1 82
byte 1 32
byte 1 0
align 1
LABELV $219
byte 1 69
byte 1 84
byte 1 95
byte 1 80
byte 1 85
byte 1 83
byte 1 72
byte 1 95
byte 1 84
byte 1 82
byte 1 73
byte 1 71
byte 1 71
byte 1 69
byte 1 82
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 0
align 1
LABELV $217
byte 1 69
byte 1 84
byte 1 95
byte 1 83
byte 1 80
byte 1 69
byte 1 65
byte 1 75
byte 1 69
byte 1 82
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 0
align 1
LABELV $215
byte 1 69
byte 1 84
byte 1 95
byte 1 80
byte 1 79
byte 1 82
byte 1 84
byte 1 65
byte 1 76
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 0
align 1
LABELV $213
byte 1 69
byte 1 84
byte 1 95
byte 1 66
byte 1 69
byte 1 65
byte 1 77
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 0
align 1
LABELV $211
byte 1 69
byte 1 84
byte 1 95
byte 1 77
byte 1 79
byte 1 86
byte 1 69
byte 1 82
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 0
align 1
LABELV $209
byte 1 69
byte 1 84
byte 1 95
byte 1 77
byte 1 73
byte 1 83
byte 1 83
byte 1 73
byte 1 76
byte 1 69
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 0
align 1
LABELV $207
byte 1 69
byte 1 84
byte 1 95
byte 1 73
byte 1 84
byte 1 69
byte 1 77
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 0
align 1
LABELV $205
byte 1 69
byte 1 84
byte 1 95
byte 1 80
byte 1 76
byte 1 65
byte 1 89
byte 1 69
byte 1 82
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 0
align 1
LABELV $203
byte 1 69
byte 1 84
byte 1 95
byte 1 71
byte 1 69
byte 1 78
byte 1 69
byte 1 82
byte 1 65
byte 1 76
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 32
byte 1 0
align 1
LABELV $198
byte 1 37
byte 1 51
byte 1 105
byte 1 58
byte 1 0
align 1
LABELV $188
byte 1 68
byte 1 105
byte 1 100
byte 1 110
byte 1 39
byte 1 116
byte 1 32
byte 1 102
byte 1 105
byte 1 110
byte 1 100
byte 1 32
byte 1 37
byte 1 115
byte 1 46
byte 1 10
byte 1 0
align 1
LABELV $187
byte 1 82
byte 1 101
byte 1 109
byte 1 111
byte 1 118
byte 1 101
byte 1 100
byte 1 46
byte 1 10
byte 1 0
align 1
LABELV $175
byte 1 85
byte 1 115
byte 1 97
byte 1 103
byte 1 101
byte 1 58
byte 1 32
byte 1 32
byte 1 115
byte 1 118
byte 1 32
byte 1 114
byte 1 101
byte 1 109
byte 1 111
byte 1 118
byte 1 101
byte 1 105
byte 1 112
byte 1 32
byte 1 60
byte 1 105
byte 1 112
byte 1 45
byte 1 109
byte 1 97
byte 1 115
byte 1 107
byte 1 62
byte 1 10
byte 1 0
align 1
LABELV $171
byte 1 85
byte 1 115
byte 1 97
byte 1 103
byte 1 101
byte 1 58
byte 1 32
byte 1 32
byte 1 97
byte 1 100
byte 1 100
byte 1 105
byte 1 112
byte 1 32
byte 1 60
byte 1 105
byte 1 112
byte 1 45
byte 1 109
byte 1 97
byte 1 115
byte 1 107
byte 1 62
byte 1 10
byte 1 0
align 1
LABELV $150
byte 1 73
byte 1 80
byte 1 32
byte 1 102
byte 1 105
byte 1 108
byte 1 116
byte 1 101
byte 1 114
byte 1 32
byte 1 108
byte 1 105
byte 1 115
byte 1 116
byte 1 32
byte 1 105
byte 1 115
byte 1 32
byte 1 102
byte 1 117
byte 1 108
byte 1 108
byte 1 10
byte 1 0
align 1
LABELV $110
byte 1 103
byte 1 95
byte 1 98
byte 1 97
byte 1 110
byte 1 73
byte 1 80
byte 1 115
byte 1 0
align 1
LABELV $109
byte 1 103
byte 1 95
byte 1 98
byte 1 97
byte 1 110
byte 1 73
byte 1 80
byte 1 115
byte 1 32
byte 1 111
byte 1 118
byte 1 101
byte 1 114
byte 1 102
byte 1 108
byte 1 111
byte 1 119
byte 1 101
byte 1 100
byte 1 32
byte 1 97
byte 1 116
byte 1 32
byte 1 77
byte 1 65
byte 1 88
byte 1 95
byte 1 67
byte 1 86
byte 1 65
byte 1 82
byte 1 95
byte 1 86
byte 1 65
byte 1 76
byte 1 85
byte 1 69
byte 1 95
byte 1 83
byte 1 84
byte 1 82
byte 1 73
byte 1 78
byte 1 71
byte 1 10
byte 1 0
align 1
LABELV $103
byte 1 32
byte 1 0
align 1
LABELV $102
byte 1 46
byte 1 0
align 1
LABELV $101
byte 1 37
byte 1 105
byte 1 0
align 1
LABELV $100
byte 1 42
byte 1 0
align 1
LABELV $78
byte 1 66
byte 1 97
byte 1 100
byte 1 32
byte 1 102
byte 1 105
byte 1 108
byte 1 116
byte 1 101
byte 1 114
byte 1 32
byte 1 97
byte 1 100
byte 1 100
byte 1 114
byte 1 101
byte 1 115
byte 1 115
byte 1 58
byte 1 32
byte 1 37
byte 1 115
byte 1 10
byte 1 0
