export allowedVote
code
proc allowedVote 288 12
file "../../../code/game/g_vote.c"
line 32
;1:/*
;2:===========================================================================
;3:Copyright (C) 2008-2009 Poul Sander
;4:
;5:This file is part of Open Arena source code.
;6:
;7:Open Arena source code is free software; you can redistribute it
;8:and/or modify it under the terms of the GNU General Public License as
;9:published by the Free Software Foundation; either version 2 of the License,
;10:or (at your option) any later version.
;11:
;12:Open Arena source code is distributed in the hope that it will be
;13:useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
;14:MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;15:GNU General Public License for more details.
;16:
;17:You should have received a copy of the GNU General Public License
;18:along with Open Arena source code; if not, write to the Free Software
;19:Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
;20:===========================================================================
;21:*/
;22:
;23:#include "g_local.h"
;24:
;25:/*
;26:==================
;27:allowedVote
;28: *Note: Keep this in sync with allowedVote in ui_votemenu.c (except for cg_voteNames and g_voteNames)
;29:==================
;30: */
;31:#define MAX_VOTENAME_LENGTH 14 //currently the longest string is "/map_restart/\0" (14 chars)
;32:int allowedVote(char *commandStr) {
line 36
;33:    char tempStr[MAX_VOTENAME_LENGTH];
;34:    int length;
;35:    char voteNames[MAX_CVAR_VALUE_STRING];
;36:    trap_Cvar_VariableStringBuffer( "g_voteNames", voteNames, sizeof( voteNames ) );
ADDRGP4 $63
ARGP4
ADDRLP4 20
ARGP4
CNSTI4 256
ARGI4
ADDRGP4 trap_Cvar_VariableStringBuffer
CALLV
pop
line 37
;37:    if(!Q_stricmp(voteNames, "*" ))
ADDRLP4 20
ARGP4
ADDRGP4 $66
ARGP4
ADDRLP4 276
ADDRGP4 Q_stricmp
CALLI4
ASGNI4
ADDRLP4 276
INDIRI4
CNSTI4 0
NEI4 $64
line 38
;38:        return qtrue; //if star, everything is allowed
CNSTI4 1
RETI4
ADDRGP4 $62
JUMPV
LABELV $64
line 39
;39:    length = strlen(commandStr);
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 280
ADDRGP4 strlen
CALLI4
ASGNI4
ADDRLP4 16
ADDRLP4 280
INDIRI4
ASGNI4
line 40
;40:    if(length>MAX_VOTENAME_LENGTH-3)
ADDRLP4 16
INDIRI4
CNSTI4 11
LEI4 $67
line 41
;41:    {
line 43
;42:        //Error: too long
;43:        return qfalse;
CNSTI4 0
RETI4
ADDRGP4 $62
JUMPV
LABELV $67
line 46
;44:    }
;45:    //Now constructing a string that starts and ends with '/' like: "/clientkick/"
;46:    tempStr[0] = '/';
ADDRLP4 0
CNSTI1 47
ASGNI1
line 47
;47:    strncpy(&tempStr[1],commandStr,length);
ADDRLP4 0+1
ARGP4
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 16
INDIRI4
ARGI4
ADDRGP4 strncpy
CALLP4
pop
line 48
;48:    tempStr[length+1] = '/';
ADDRLP4 16
INDIRI4
ADDRLP4 0+1
ADDP4
CNSTI1 47
ASGNI1
line 49
;49:    tempStr[length+2] = '\0';
ADDRLP4 16
INDIRI4
ADDRLP4 0+2
ADDP4
CNSTI1 0
ASGNI1
line 50
;50:    if(Q_stristr(voteNames,tempStr) != NULL)
ADDRLP4 20
ARGP4
ADDRLP4 0
ARGP4
ADDRLP4 284
ADDRGP4 Q_stristr
CALLP4
ASGNP4
ADDRLP4 284
INDIRP4
CVPU4 4
CNSTU4 0
EQU4 $72
line 51
;51:        return qtrue;
CNSTI4 1
RETI4
ADDRGP4 $62
JUMPV
LABELV $72
line 53
;52:    else
;53:        return qfalse;
CNSTI4 0
RETI4
LABELV $62
endproc allowedVote 288 12
export getMappage
proc getMappage 19572 16
line 62
;54:}
;55:
;56:/*
;57:==================
;58:getMappage
;59:==================
;60: */
;61:
;62:t_mappage getMappage(int page) {
line 69
;63:	t_mappage result;
;64:	fileHandle_t	file;
;65:	char *token,*pointer;
;66:	char buffer[MAX_MAPNAME_BUFFER];
;67:	int i, nummaps,maplen;
;68:
;69:	memset(&result,0,sizeof(result));
ADDRLP4 16
ARGP4
CNSTI4 0
ARGI4
CNSTI4 324
ARGI4
ADDRGP4 memset
CALLP4
pop
line 70
;70:        memset(&buffer,0,sizeof(buffer));
ADDRLP4 344
ARGP4
CNSTI4 0
ARGI4
CNSTI4 19200
ARGI4
ADDRGP4 memset
CALLP4
pop
line 73
;71:
;72:	//Check if there is a votemaps.cfg
;73:	trap_FS_FOpenFile(g_votemaps.string,&file,FS_READ);
ADDRGP4 g_votemaps+16
ARGP4
ADDRLP4 19544
ARGP4
CNSTI4 0
ARGI4
ADDRGP4 trap_FS_FOpenFile
CALLI4
pop
line 74
;74:	if(file)
ADDRLP4 19544
INDIRI4
CNSTI4 0
EQI4 $77
line 75
;75:	{
line 77
;76:		//there is a votemaps.cfg file, take allowed maps from there
;77:		trap_FS_Read(&buffer,sizeof(buffer),file);
ADDRLP4 344
ARGP4
CNSTI4 19200
ARGI4
ADDRLP4 19544
INDIRI4
ARGI4
ADDRGP4 trap_FS_Read
CALLV
pop
line 78
;78:		pointer = buffer;
ADDRLP4 4
ADDRLP4 344
ASGNP4
line 79
;79:		token = COM_Parse(&pointer);
ADDRLP4 4
ARGP4
ADDRLP4 19548
ADDRGP4 COM_Parse
CALLP4
ASGNP4
ADDRLP4 12
ADDRLP4 19548
INDIRP4
ASGNP4
line 80
;80:		if(token[0]==0 && page == 0) {
ADDRLP4 19552
CNSTI4 0
ASGNI4
ADDRLP4 12
INDIRP4
INDIRI1
CVII4 1
ADDRLP4 19552
INDIRI4
NEI4 $79
ADDRFP4 4
INDIRI4
ADDRLP4 19552
INDIRI4
NEI4 $79
line 82
;81:			//First page empty
;82:			result.pagenumber = -1;
ADDRLP4 16
CNSTI4 -1
ASGNI4
line 83
;83:                        trap_FS_FCloseFile(file);
ADDRLP4 19544
INDIRI4
ARGI4
ADDRGP4 trap_FS_FCloseFile
CALLV
pop
line 84
;84:			return result;
ADDRFP4 0
INDIRP4
ADDRLP4 16
INDIRB
ASGNB 324
ADDRGP4 $74
JUMPV
LABELV $79
line 87
;85:		}
;86:		//Skip the first pages
;87:		for(i=0;i<MAPS_PER_PAGE*page;i++) {
ADDRLP4 0
CNSTI4 0
ASGNI4
ADDRGP4 $84
JUMPV
LABELV $81
line 88
;88:			token = COM_Parse(&pointer);
ADDRLP4 4
ARGP4
ADDRLP4 19556
ADDRGP4 COM_Parse
CALLP4
ASGNP4
ADDRLP4 12
ADDRLP4 19556
INDIRP4
ASGNP4
line 89
;89:		}
LABELV $82
line 87
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $84
ADDRLP4 0
INDIRI4
CNSTI4 10
ADDRFP4 4
INDIRI4
MULI4
LTI4 $81
line 90
;90:		if(!token || token[0]==0) {
ADDRLP4 12
INDIRP4
CVPU4 4
CNSTU4 0
EQU4 $87
ADDRLP4 12
INDIRP4
INDIRI1
CVII4 1
CNSTI4 0
NEI4 $85
LABELV $87
line 92
;91:			//Page empty, return to first page
;92:                        trap_FS_FCloseFile(file);
ADDRLP4 19544
INDIRI4
ARGI4
ADDRGP4 trap_FS_FCloseFile
CALLV
pop
line 93
;93:			return getMappage(0);
ADDRFP4 0
INDIRP4
ARGP4
CNSTI4 0
ARGI4
ADDRGP4 getMappage
CALLV
pop
ADDRGP4 $74
JUMPV
LABELV $85
line 96
;94:		}
;95:		//There is an actual page:
;96:                result.pagenumber = page;
ADDRLP4 16
ADDRFP4 4
INDIRI4
ASGNI4
line 97
;97:		for(i=0;i<MAPS_PER_PAGE && token;i++) {
ADDRLP4 0
CNSTI4 0
ASGNI4
ADDRGP4 $91
JUMPV
LABELV $88
line 98
;98:			Q_strncpyz(result.mapname[i],token,MAX_MAPNAME);
ADDRLP4 0
INDIRI4
CNSTI4 5
LSHI4
ADDRLP4 16+4
ADDP4
ARGP4
ADDRLP4 12
INDIRP4
ARGP4
CNSTI4 32
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 99
;99:			token = COM_Parse(&pointer);
ADDRLP4 4
ARGP4
ADDRLP4 19560
ADDRGP4 COM_Parse
CALLP4
ASGNP4
ADDRLP4 12
ADDRLP4 19560
INDIRP4
ASGNP4
line 100
;100:		}
LABELV $89
line 97
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $91
ADDRLP4 0
INDIRI4
CNSTI4 10
GEI4 $93
ADDRLP4 12
INDIRP4
CVPU4 4
CNSTU4 0
NEU4 $88
LABELV $93
line 101
;101:                trap_FS_FCloseFile(file);
ADDRLP4 19544
INDIRI4
ARGI4
ADDRGP4 trap_FS_FCloseFile
CALLV
pop
line 102
;102:		return result;
ADDRFP4 0
INDIRP4
ADDRLP4 16
INDIRB
ASGNB 324
ADDRGP4 $74
JUMPV
LABELV $77
line 105
;103:	}
;104:        //There is no votemaps.cfg file, find filelist of maps
;105:        nummaps = trap_FS_GetFileList("maps",".bsp",buffer,sizeof(buffer));
ADDRGP4 $94
ARGP4
ADDRGP4 $95
ARGP4
ADDRLP4 344
ARGP4
CNSTI4 19200
ARGI4
ADDRLP4 19548
ADDRGP4 trap_FS_GetFileList
CALLI4
ASGNI4
ADDRLP4 340
ADDRLP4 19548
INDIRI4
ASGNI4
line 107
;106:
;107:        if(nummaps && nummaps<=MAPS_PER_PAGE*page)
ADDRLP4 340
INDIRI4
CNSTI4 0
EQI4 $96
ADDRLP4 340
INDIRI4
CNSTI4 10
ADDRFP4 4
INDIRI4
MULI4
GTI4 $96
line 108
;108:            return getMappage(0);
ADDRFP4 0
INDIRP4
ARGP4
CNSTI4 0
ARGI4
ADDRGP4 getMappage
CALLV
pop
ADDRGP4 $74
JUMPV
LABELV $96
line 110
;109:
;110:        pointer = buffer;
ADDRLP4 4
ADDRLP4 344
ASGNP4
line 111
;111:        result.pagenumber = page;
ADDRLP4 16
ADDRFP4 4
INDIRI4
ASGNI4
line 113
;112:
;113:        for (i = 0; i < nummaps; i++, pointer += maplen+1) {
ADDRLP4 0
CNSTI4 0
ASGNI4
ADDRGP4 $101
JUMPV
LABELV $98
line 114
;114:		maplen = strlen(pointer);
ADDRLP4 4
INDIRP4
ARGP4
ADDRLP4 19556
ADDRGP4 strlen
CALLI4
ASGNI4
ADDRLP4 8
ADDRLP4 19556
INDIRI4
ASGNI4
line 115
;115:                if(i>=MAPS_PER_PAGE*page && i<MAPS_PER_PAGE*(page+1)) {
ADDRLP4 19564
CNSTI4 10
ASGNI4
ADDRLP4 19568
ADDRLP4 19564
INDIRI4
ADDRFP4 4
INDIRI4
MULI4
ASGNI4
ADDRLP4 0
INDIRI4
ADDRLP4 19568
INDIRI4
LTI4 $102
ADDRLP4 0
INDIRI4
ADDRLP4 19568
INDIRI4
ADDRLP4 19564
INDIRI4
ADDI4
GEI4 $102
line 116
;116:                    Q_strncpyz(result.mapname[i-MAPS_PER_PAGE*page],pointer,maplen-3);
ADDRLP4 0
INDIRI4
CNSTI4 10
ADDRFP4 4
INDIRI4
MULI4
SUBI4
CNSTI4 5
LSHI4
ADDRLP4 16+4
ADDP4
ARGP4
ADDRLP4 4
INDIRP4
ARGP4
ADDRLP4 8
INDIRI4
CNSTI4 3
SUBI4
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 117
;117:                }
LABELV $102
line 118
;118:	}
LABELV $99
line 113
ADDRLP4 19556
CNSTI4 1
ASGNI4
ADDRLP4 0
ADDRLP4 0
INDIRI4
ADDRLP4 19556
INDIRI4
ADDI4
ASGNI4
ADDRLP4 4
ADDRLP4 8
INDIRI4
ADDRLP4 19556
INDIRI4
ADDI4
ADDRLP4 4
INDIRP4
ADDP4
ASGNP4
LABELV $101
ADDRLP4 0
INDIRI4
ADDRLP4 340
INDIRI4
LTI4 $98
line 119
;119:        return result;
ADDRFP4 0
INDIRP4
ADDRLP4 16
INDIRB
ASGNB 324
LABELV $74
endproc getMappage 19572 16
export allowedMap
proc allowedMap 8232 12
line 129
;120:
;121:}
;122:
;123:/*
;124:==================
;125:allowedMap
;126:==================
;127: */
;128:
;129:int allowedMap(char *mapname) {
line 136
;130:    int length;
;131:    fileHandle_t	file;           //To check that the map actually exists.
;132:    char                buffer[MAX_MAPS_TEXT];
;133:    char                *token,*pointer;
;134:    qboolean            found;
;135:
;136:    trap_FS_FOpenFile(va("maps/%s.bsp",mapname),&file,FS_READ);
ADDRGP4 $106
ARGP4
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 8212
ADDRGP4 va
CALLP4
ASGNP4
ADDRLP4 8212
INDIRP4
ARGP4
ADDRLP4 12
ARGP4
CNSTI4 0
ARGI4
ADDRGP4 trap_FS_FOpenFile
CALLI4
pop
line 137
;137:    if(!file)
ADDRLP4 12
INDIRI4
CNSTI4 0
NEI4 $107
line 138
;138:        return qfalse; //maps/MAPNAME.bsp does not exist
CNSTI4 0
RETI4
ADDRGP4 $105
JUMPV
LABELV $107
line 139
;139:    trap_FS_FCloseFile(file);
ADDRLP4 12
INDIRI4
ARGI4
ADDRGP4 trap_FS_FCloseFile
CALLV
pop
line 142
;140:
;141:    //Now read the file votemaps.cfg to see what maps are allowed
;142:    trap_FS_FOpenFile(g_votemaps.string,&file,FS_READ);
ADDRGP4 g_votemaps+16
ARGP4
ADDRLP4 12
ARGP4
CNSTI4 0
ARGI4
ADDRGP4 trap_FS_FOpenFile
CALLI4
pop
line 144
;143:
;144:    if(!file)
ADDRLP4 12
INDIRI4
CNSTI4 0
NEI4 $110
line 145
;145:        return qtrue; //if no file, everything is allowed
CNSTI4 1
RETI4
ADDRGP4 $105
JUMPV
LABELV $110
line 146
;146:    length = strlen(mapname);
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 8216
ADDRGP4 strlen
CALLI4
ASGNI4
ADDRLP4 16
ADDRLP4 8216
INDIRI4
ASGNI4
line 147
;147:    if(length>MAX_MAPNAME_LENGTH-3)
ADDRLP4 16
INDIRI4
CNSTI4 31
LEI4 $112
line 148
;148:    {
line 150
;149:        //Error: too long
;150:        trap_FS_FCloseFile(file);
ADDRLP4 12
INDIRI4
ARGI4
ADDRGP4 trap_FS_FCloseFile
CALLV
pop
line 151
;151:        return qfalse;
CNSTI4 0
RETI4
ADDRGP4 $105
JUMPV
LABELV $112
line 155
;152:    }
;153:
;154:    //Add file checking here
;155:    trap_FS_Read(&buffer,MAX_MAPS_TEXT,file);
ADDRLP4 20
ARGP4
CNSTI4 8192
ARGI4
ADDRLP4 12
INDIRI4
ARGI4
ADDRGP4 trap_FS_Read
CALLV
pop
line 156
;156:    found = qfalse;
ADDRLP4 4
CNSTI4 0
ASGNI4
line 157
;157:    pointer = buffer;
ADDRLP4 8
ADDRLP4 20
ASGNP4
line 158
;158:    token = COM_Parse(&pointer);
ADDRLP4 8
ARGP4
ADDRLP4 8220
ADDRGP4 COM_Parse
CALLP4
ASGNP4
ADDRLP4 0
ADDRLP4 8220
INDIRP4
ASGNP4
ADDRGP4 $115
JUMPV
LABELV $114
line 159
;159:    while(token[0]!=0 && !found) {
line 160
;160:        if(!Q_stricmp(token,mapname))
ADDRLP4 0
INDIRP4
ARGP4
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 8224
ADDRGP4 Q_stricmp
CALLI4
ASGNI4
ADDRLP4 8224
INDIRI4
CNSTI4 0
NEI4 $117
line 161
;161:            found = qtrue;
ADDRLP4 4
CNSTI4 1
ASGNI4
LABELV $117
line 162
;162:        token = COM_Parse(&pointer);
ADDRLP4 8
ARGP4
ADDRLP4 8228
ADDRGP4 COM_Parse
CALLP4
ASGNP4
ADDRLP4 0
ADDRLP4 8228
INDIRP4
ASGNP4
line 163
;163:    }
LABELV $115
line 159
ADDRLP4 8224
CNSTI4 0
ASGNI4
ADDRLP4 0
INDIRP4
INDIRI1
CVII4 1
ADDRLP4 8224
INDIRI4
EQI4 $119
ADDRLP4 4
INDIRI4
ADDRLP4 8224
INDIRI4
EQI4 $114
LABELV $119
line 165
;164:
;165:    trap_FS_FCloseFile(file);
ADDRLP4 12
INDIRI4
ARGI4
ADDRGP4 trap_FS_FCloseFile
CALLV
pop
line 167
;166:    //The map was not found
;167:    return found;
ADDRLP4 4
INDIRI4
RETI4
LABELV $105
endproc allowedMap 8232 12
export allowedGametype
proc allowedGametype 280 12
line 176
;168:}
;169:
;170:/*
;171:==================
;172:allowedGametype
;173:==================
;174: */
;175:#define MAX_GAMETYPENAME_LENGTH 5 //currently the longest string is "/12/\0" (5 chars)
;176:int allowedGametype(char *gametypeStr) {
line 180
;177:    char tempStr[MAX_GAMETYPENAME_LENGTH];
;178:    int length;
;179:    char voteGametypes[MAX_CVAR_VALUE_STRING];
;180:    trap_Cvar_VariableStringBuffer( "g_voteGametypes", voteGametypes, sizeof( voteGametypes ) );
ADDRGP4 $121
ARGP4
ADDRLP4 12
ARGP4
CNSTI4 256
ARGI4
ADDRGP4 trap_Cvar_VariableStringBuffer
CALLV
pop
line 181
;181:    if(!Q_stricmp(voteGametypes, "*" ))
ADDRLP4 12
ARGP4
ADDRGP4 $66
ARGP4
ADDRLP4 268
ADDRGP4 Q_stricmp
CALLI4
ASGNI4
ADDRLP4 268
INDIRI4
CNSTI4 0
NEI4 $122
line 182
;182:        return qtrue; //if star, everything is allowed
CNSTI4 1
RETI4
ADDRGP4 $120
JUMPV
LABELV $122
line 183
;183:    length = strlen(gametypeStr);
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 272
ADDRGP4 strlen
CALLI4
ASGNI4
ADDRLP4 8
ADDRLP4 272
INDIRI4
ASGNI4
line 184
;184:    if(length>MAX_GAMETYPENAME_LENGTH-3)
ADDRLP4 8
INDIRI4
CNSTI4 2
LEI4 $124
line 185
;185:    {
line 187
;186:        //Error: too long
;187:        return qfalse;
CNSTI4 0
RETI4
ADDRGP4 $120
JUMPV
LABELV $124
line 189
;188:    }
;189:    tempStr[0] = '/';
ADDRLP4 0
CNSTI1 47
ASGNI1
line 190
;190:    strncpy(&tempStr[1],gametypeStr,length);
ADDRLP4 0+1
ARGP4
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 8
INDIRI4
ARGI4
ADDRGP4 strncpy
CALLP4
pop
line 191
;191:    tempStr[length+1] = '/';
ADDRLP4 8
INDIRI4
ADDRLP4 0+1
ADDP4
CNSTI1 47
ASGNI1
line 192
;192:    tempStr[length+2] = '\0';
ADDRLP4 8
INDIRI4
ADDRLP4 0+2
ADDP4
CNSTI1 0
ASGNI1
line 193
;193:    if(Q_stristr(voteGametypes,tempStr) != NULL)
ADDRLP4 12
ARGP4
ADDRLP4 0
ARGP4
ADDRLP4 276
ADDRGP4 Q_stristr
CALLP4
ASGNP4
ADDRLP4 276
INDIRP4
CVPU4 4
CNSTU4 0
EQU4 $129
line 194
;194:        return qtrue;
CNSTI4 1
RETI4
ADDRGP4 $120
JUMPV
LABELV $129
line 195
;195:    else {
line 196
;196:        return qfalse;
CNSTI4 0
RETI4
LABELV $120
endproc allowedGametype 280 12
export allowedTimelimit
proc allowedTimelimit 20 0
line 205
;197:    }
;198:}
;199:
;200:/*
;201:==================
;202:allowedTimelimit
;203:==================
;204: */
;205:int allowedTimelimit(int limit) {
line 207
;206:    int min, max;
;207:    min = g_voteMinTimelimit.integer;
ADDRLP4 4
ADDRGP4 g_voteMinTimelimit+12
INDIRI4
ASGNI4
line 208
;208:    max = g_voteMaxTimelimit.integer;
ADDRLP4 0
ADDRGP4 g_voteMaxTimelimit+12
INDIRI4
ASGNI4
line 209
;209:    if(limit<min && limit != 0)
ADDRLP4 8
ADDRFP4 0
INDIRI4
ASGNI4
ADDRLP4 8
INDIRI4
ADDRLP4 4
INDIRI4
GEI4 $134
ADDRLP4 8
INDIRI4
CNSTI4 0
EQI4 $134
line 210
;210:        return qfalse;
CNSTI4 0
RETI4
ADDRGP4 $131
JUMPV
LABELV $134
line 211
;211:    if(max!=0 && limit>max)
ADDRLP4 0
INDIRI4
CNSTI4 0
EQI4 $136
ADDRFP4 0
INDIRI4
ADDRLP4 0
INDIRI4
LEI4 $136
line 212
;212:        return qfalse;
CNSTI4 0
RETI4
ADDRGP4 $131
JUMPV
LABELV $136
line 213
;213:    if(limit==0 && max > 0)
ADDRLP4 16
CNSTI4 0
ASGNI4
ADDRFP4 0
INDIRI4
ADDRLP4 16
INDIRI4
NEI4 $138
ADDRLP4 0
INDIRI4
ADDRLP4 16
INDIRI4
LEI4 $138
line 214
;214:        return qfalse;
CNSTI4 0
RETI4
ADDRGP4 $131
JUMPV
LABELV $138
line 215
;215:    return qtrue;
CNSTI4 1
RETI4
LABELV $131
endproc allowedTimelimit 20 0
export allowedFraglimit
proc allowedFraglimit 20 0
line 223
;216:}
;217:
;218:/*
;219:==================
;220:allowedFraglimit
;221:==================
;222: */
;223:int allowedFraglimit(int limit) {
line 225
;224:    int min, max;
;225:    min = g_voteMinFraglimit.integer;
ADDRLP4 4
ADDRGP4 g_voteMinFraglimit+12
INDIRI4
ASGNI4
line 226
;226:    max = g_voteMaxFraglimit.integer;
ADDRLP4 0
ADDRGP4 g_voteMaxFraglimit+12
INDIRI4
ASGNI4
line 227
;227:    if(limit<min && limit != 0)
ADDRLP4 8
ADDRFP4 0
INDIRI4
ASGNI4
ADDRLP4 8
INDIRI4
ADDRLP4 4
INDIRI4
GEI4 $143
ADDRLP4 8
INDIRI4
CNSTI4 0
EQI4 $143
line 228
;228:        return qfalse;
CNSTI4 0
RETI4
ADDRGP4 $140
JUMPV
LABELV $143
line 229
;229:    if(max != 0 && limit>max)
ADDRLP4 0
INDIRI4
CNSTI4 0
EQI4 $145
ADDRFP4 0
INDIRI4
ADDRLP4 0
INDIRI4
LEI4 $145
line 230
;230:        return qfalse;
CNSTI4 0
RETI4
ADDRGP4 $140
JUMPV
LABELV $145
line 231
;231:    if(limit==0 && max > 0)
ADDRLP4 16
CNSTI4 0
ASGNI4
ADDRFP4 0
INDIRI4
ADDRLP4 16
INDIRI4
NEI4 $147
ADDRLP4 0
INDIRI4
ADDRLP4 16
INDIRI4
LEI4 $147
line 232
;232:        return qfalse;
CNSTI4 0
RETI4
ADDRGP4 $140
JUMPV
LABELV $147
line 233
;233:    return qtrue;
CNSTI4 1
RETI4
LABELV $140
endproc allowedFraglimit 20 0
export VoteParseCustomVotes
proc VoteParseCustomVotes 4128 12
line 247
;234:}
;235:
;236:#define MAX_CUSTOM_VOTES    12
;237:
;238:char            custom_vote_info[1024];
;239:
;240:/*
;241:==================
;242:VoteParseCustomVotes
;243: *Reads the file votecustom.cfg. Finds all the commands that can be used with
;244: *"/callvote custom COMMAND" and adds the commands to custom_vote_info
;245:==================
;246: */
;247:int VoteParseCustomVotes( void ) {
line 253
;248:    fileHandle_t	file;
;249:    char            buffer[4*1024];
;250:    int             commands;
;251:    char	*token,*pointer;
;252:
;253:    trap_FS_FOpenFile(g_votecustom.string,&file,FS_READ);
ADDRGP4 g_votecustom+16
ARGP4
ADDRLP4 4108
ARGP4
CNSTI4 0
ARGI4
ADDRGP4 trap_FS_FOpenFile
CALLI4
pop
line 255
;254:
;255:    if(!file)
ADDRLP4 4108
INDIRI4
CNSTI4 0
NEI4 $151
line 256
;256:        return 0;
CNSTI4 0
RETI4
ADDRGP4 $149
JUMPV
LABELV $151
line 258
;257:
;258:    memset(&buffer,0,sizeof(buffer));
ADDRLP4 12
ARGP4
CNSTI4 0
ARGI4
CNSTI4 4096
ARGI4
ADDRGP4 memset
CALLP4
pop
line 259
;259:    memset(&custom_vote_info,0,sizeof(custom_vote_info));
ADDRGP4 custom_vote_info
ARGP4
CNSTI4 0
ARGI4
CNSTI4 1024
ARGI4
ADDRGP4 memset
CALLP4
pop
line 261
;260:
;261:    commands = 0;
ADDRLP4 4
CNSTI4 0
ASGNI4
line 263
;262:
;263:    trap_FS_Read(&buffer,sizeof(buffer),file);
ADDRLP4 12
ARGP4
CNSTI4 4096
ARGI4
ADDRLP4 4108
INDIRI4
ARGI4
ADDRGP4 trap_FS_Read
CALLV
pop
line 265
;264:    
;265:    pointer = buffer;
ADDRLP4 8
ADDRLP4 12
ASGNP4
ADDRGP4 $154
JUMPV
LABELV $153
line 267
;266:
;267:    while ( commands < MAX_CUSTOM_VOTES ) {
line 268
;268:	token = COM_Parse( &pointer );
ADDRLP4 8
ARGP4
ADDRLP4 4112
ADDRGP4 COM_Parse
CALLP4
ASGNP4
ADDRLP4 0
ADDRLP4 4112
INDIRP4
ASGNP4
line 269
;269:        if ( !token[0] ) {
ADDRLP4 0
INDIRP4
INDIRI1
CVII4 1
CNSTI4 0
NEI4 $156
line 270
;270:            break;
ADDRGP4 $155
JUMPV
LABELV $156
line 273
;271:	}
;272:
;273:        if ( !strcmp( token, "votecommand" ) ) {
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 $160
ARGP4
ADDRLP4 4116
ADDRGP4 strcmp
CALLI4
ASGNI4
ADDRLP4 4116
INDIRI4
CNSTI4 0
NEI4 $158
line 274
;274:            token = COM_Parse( &pointer );
ADDRLP4 8
ARGP4
ADDRLP4 4120
ADDRGP4 COM_Parse
CALLP4
ASGNP4
ADDRLP4 0
ADDRLP4 4120
INDIRP4
ASGNP4
line 275
;275:            Q_strcat(custom_vote_info,sizeof(custom_vote_info),va("%s ",token));
ADDRGP4 $161
ARGP4
ADDRLP4 0
INDIRP4
ARGP4
ADDRLP4 4124
ADDRGP4 va
CALLP4
ASGNP4
ADDRGP4 custom_vote_info
ARGP4
CNSTI4 1024
ARGI4
ADDRLP4 4124
INDIRP4
ARGP4
ADDRGP4 Q_strcat
CALLV
pop
line 276
;276:            commands++;
ADDRLP4 4
ADDRLP4 4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
line 277
;277:	}
LABELV $158
line 278
;278:    }
LABELV $154
line 267
ADDRLP4 4
INDIRI4
CNSTI4 12
LTI4 $153
LABELV $155
line 280
;279:
;280:    trap_FS_FCloseFile(file);
ADDRLP4 4108
INDIRI4
ARGI4
ADDRGP4 trap_FS_FCloseFile
CALLV
pop
line 282
;281:
;282:    return commands;
ADDRLP4 4
INDIRI4
RETI4
LABELV $149
endproc VoteParseCustomVotes 4128 12
export getCustomVote
proc getCustomVote 5348 12
line 290
;283:}
;284:/*
;285:==================
;286:getCustomVote
;287: *Returns a custom vote. This will go beyond MAX_CUSTOM_VOTES.
;288:==================
;289: */
;290:t_customvote getCustomVote(char* votecommand) {
line 297
;291:    t_customvote result;
;292:    fileHandle_t	file;
;293:    char            buffer[4*1024];
;294:    char	*token,*pointer;
;295:    char	key[MAX_TOKEN_CHARS];
;296:
;297:    trap_FS_FOpenFile(g_votecustom.string,&file,FS_READ);
ADDRGP4 g_votecustom+16
ARGP4
ADDRLP4 5312
ARGP4
CNSTI4 0
ARGI4
ADDRGP4 trap_FS_FOpenFile
CALLI4
pop
line 299
;298:
;299:    if(!file) {
ADDRLP4 5312
INDIRI4
CNSTI4 0
NEI4 $165
line 300
;300:        memset(&result,0,sizeof(result));
ADDRLP4 1028
ARGP4
CNSTI4 0
ARGI4
CNSTI4 184
ARGI4
ADDRGP4 memset
CALLP4
pop
line 301
;301:        return result;
ADDRFP4 0
INDIRP4
ADDRLP4 1028
INDIRB
ASGNB 184
ADDRGP4 $162
JUMPV
LABELV $165
line 304
;302:    }
;303:
;304:    memset(&buffer,0,sizeof(buffer));
ADDRLP4 1216
ARGP4
CNSTI4 0
ARGI4
CNSTI4 4096
ARGI4
ADDRGP4 memset
CALLP4
pop
line 306
;305:
;306:    trap_FS_Read(&buffer,sizeof(buffer),file);
ADDRLP4 1216
ARGP4
CNSTI4 4096
ARGI4
ADDRLP4 5312
INDIRI4
ARGI4
ADDRGP4 trap_FS_Read
CALLV
pop
line 308
;307:
;308:    pointer = buffer;
ADDRLP4 1212
ADDRLP4 1216
ASGNP4
ADDRGP4 $168
JUMPV
LABELV $167
line 310
;309:
;310:    while ( qtrue ) {
line 311
;311:	token = COM_Parse( &pointer );
ADDRLP4 1212
ARGP4
ADDRLP4 5316
ADDRGP4 COM_Parse
CALLP4
ASGNP4
ADDRLP4 0
ADDRLP4 5316
INDIRP4
ASGNP4
line 312
;312:        if ( !token[0] ) {
ADDRLP4 0
INDIRP4
INDIRI1
CVII4 1
CNSTI4 0
NEI4 $170
line 313
;313:            break;
ADDRGP4 $169
JUMPV
LABELV $170
line 316
;314:	}
;315:
;316:        if ( strcmp( token, "{" ) ) {
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 $174
ARGP4
ADDRLP4 5320
ADDRGP4 strcmp
CALLI4
ASGNI4
ADDRLP4 5320
INDIRI4
CNSTI4 0
EQI4 $172
line 317
;317:		Com_Printf( "Missing { in votecustom.cfg\n" );
ADDRGP4 $175
ARGP4
ADDRGP4 Com_Printf
CALLV
pop
line 318
;318:		break;
ADDRGP4 $169
JUMPV
LABELV $172
line 321
;319:	}
;320:
;321:        memset(&result,0,sizeof(result));
ADDRLP4 1028
ARGP4
CNSTI4 0
ARGI4
CNSTI4 184
ARGI4
ADDRGP4 memset
CALLP4
pop
ADDRGP4 $177
JUMPV
LABELV $176
line 323
;322:
;323:        while ( 1 ) {
line 324
;324:            token = COM_ParseExt( &pointer, qtrue );
ADDRLP4 1212
ARGP4
CNSTI4 1
ARGI4
ADDRLP4 5324
ADDRGP4 COM_ParseExt
CALLP4
ASGNP4
ADDRLP4 0
ADDRLP4 5324
INDIRP4
ASGNP4
line 325
;325:            if ( !token[0] ) {
ADDRLP4 0
INDIRP4
INDIRI1
CVII4 1
CNSTI4 0
NEI4 $179
line 326
;326:                    Com_Printf( "Unexpected end of customvote.cfg\n" );
ADDRGP4 $181
ARGP4
ADDRGP4 Com_Printf
CALLV
pop
line 327
;327:                    break;
ADDRGP4 $178
JUMPV
LABELV $179
line 329
;328:            }
;329:            if ( !strcmp( token, "}" ) ) {
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 $184
ARGP4
ADDRLP4 5328
ADDRGP4 strcmp
CALLI4
ASGNI4
ADDRLP4 5328
INDIRI4
CNSTI4 0
NEI4 $182
line 330
;330:                    break;
ADDRGP4 $178
JUMPV
LABELV $182
line 332
;331:            }
;332:            Q_strncpyz( key, token, sizeof( key ) );
ADDRLP4 4
ARGP4
ADDRLP4 0
INDIRP4
ARGP4
CNSTI4 1024
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 334
;333:
;334:            token = COM_ParseExt( &pointer, qfalse );
ADDRLP4 1212
ARGP4
CNSTI4 0
ARGI4
ADDRLP4 5332
ADDRGP4 COM_ParseExt
CALLP4
ASGNP4
ADDRLP4 0
ADDRLP4 5332
INDIRP4
ASGNP4
line 335
;335:            if ( !token[0] ) {
ADDRLP4 0
INDIRP4
INDIRI1
CVII4 1
CNSTI4 0
NEI4 $185
line 336
;336:                Com_Printf("Invalid/missing argument to %s in customvote.cfg\n",key);
ADDRGP4 $187
ARGP4
ADDRLP4 4
ARGP4
ADDRGP4 Com_Printf
CALLV
pop
line 337
;337:            }
LABELV $185
line 338
;338:            if(!Q_stricmp(key,"votecommand")) {
ADDRLP4 4
ARGP4
ADDRGP4 $160
ARGP4
ADDRLP4 5336
ADDRGP4 Q_stricmp
CALLI4
ASGNI4
ADDRLP4 5336
INDIRI4
CNSTI4 0
NEI4 $188
line 339
;339:                Q_strncpyz(result.votename,token,sizeof(result.votename));
ADDRLP4 1028
ARGP4
ADDRLP4 0
INDIRP4
ARGP4
CNSTI4 32
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 340
;340:            } else if(!Q_stricmp(key,"displayname")) {
ADDRGP4 $189
JUMPV
LABELV $188
ADDRLP4 4
ARGP4
ADDRGP4 $192
ARGP4
ADDRLP4 5340
ADDRGP4 Q_stricmp
CALLI4
ASGNI4
ADDRLP4 5340
INDIRI4
CNSTI4 0
NEI4 $190
line 341
;341:                Q_strncpyz(result.displayname,token,sizeof(result.displayname));
ADDRLP4 1028+32
ARGP4
ADDRLP4 0
INDIRP4
ARGP4
CNSTI4 50
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 342
;342:            } else if(!Q_stricmp(key,"command")) {
ADDRGP4 $191
JUMPV
LABELV $190
ADDRLP4 4
ARGP4
ADDRGP4 $197
ARGP4
ADDRLP4 5344
ADDRGP4 Q_stricmp
CALLI4
ASGNI4
ADDRLP4 5344
INDIRI4
CNSTI4 0
NEI4 $195
line 343
;343:                Q_strncpyz(result.command,token,sizeof(result.command));
ADDRLP4 1028+82
ARGP4
ADDRLP4 0
INDIRP4
ARGP4
CNSTI4 100
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 344
;344:            } else {
ADDRGP4 $196
JUMPV
LABELV $195
line 345
;345:                Com_Printf("Unknown key in customvote.cfg: %s\n",key);
ADDRGP4 $200
ARGP4
ADDRLP4 4
ARGP4
ADDRGP4 Com_Printf
CALLV
pop
line 346
;346:            }
LABELV $196
LABELV $191
LABELV $189
line 348
;347:
;348:	}
LABELV $177
line 323
ADDRGP4 $176
JUMPV
LABELV $178
line 350
;349:
;350:        if(!Q_stricmp(result.votename,votecommand)) {
ADDRLP4 1028
ARGP4
ADDRFP4 4
INDIRP4
ARGP4
ADDRLP4 5324
ADDRGP4 Q_stricmp
CALLI4
ASGNI4
ADDRLP4 5324
INDIRI4
CNSTI4 0
NEI4 $201
line 351
;351:            return result;
ADDRFP4 0
INDIRP4
ADDRLP4 1028
INDIRB
ASGNB 184
ADDRGP4 $162
JUMPV
LABELV $201
line 353
;352:        }
;353:    }
LABELV $168
line 310
ADDRGP4 $167
JUMPV
LABELV $169
line 356
;354:
;355:    //Nothing was found
;356:    memset(&result,0,sizeof(result));
ADDRLP4 1028
ARGP4
CNSTI4 0
ARGI4
CNSTI4 184
ARGI4
ADDRGP4 memset
CALLP4
pop
line 357
;357:        return result;
ADDRFP4 0
INDIRP4
ADDRLP4 1028
INDIRB
ASGNB 184
LABELV $162
endproc getCustomVote 5348 12
export CheckVote
proc CheckVote 4 8
line 365
;358:}
;359:
;360:/*
;361:==================
;362:CheckVote
;363:==================
;364:*/
;365:void CheckVote( void ) {
line 366
;366:	if ( level.voteExecuteTime && level.voteExecuteTime < level.time ) {
ADDRGP4 level+2408
INDIRI4
CNSTI4 0
EQI4 $204
ADDRGP4 level+2408
INDIRI4
ADDRGP4 level+32
INDIRI4
GEI4 $204
line 367
;367:		level.voteExecuteTime = 0;
ADDRGP4 level+2408
CNSTI4 0
ASGNI4
line 368
;368:		trap_SendConsoleCommand( EXEC_APPEND, va("%s\n", level.voteString ) );
ADDRGP4 $210
ARGP4
ADDRGP4 level+356
ARGP4
ADDRLP4 0
ADDRGP4 va
CALLP4
ASGNP4
CNSTI4 2
ARGI4
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_SendConsoleCommand
CALLV
pop
line 369
;369:	}
LABELV $204
line 370
;370:	if ( !level.voteTime ) {
ADDRGP4 level+2404
INDIRI4
CNSTI4 0
NEI4 $212
line 371
;371:		return;
ADDRGP4 $203
JUMPV
LABELV $212
line 373
;372:	}
;373:	if ( level.time - level.voteTime >= VOTE_TIME ) {
ADDRGP4 level+32
INDIRI4
ADDRGP4 level+2404
INDIRI4
SUBI4
CNSTI4 30000
LTI4 $215
line 374
;374:            if(g_dmflags.integer & DF_LIGHT_VOTING) {
ADDRGP4 g_dmflags+12
INDIRI4
CNSTI4 512
BANDI4
CNSTI4 0
EQI4 $219
line 376
;375:                //Let pass if there was at least twice as many for as against
;376:                if ( level.voteYes > level.voteNo*2 ) {
ADDRGP4 level+2412
INDIRI4
ADDRGP4 level+2416
INDIRI4
CNSTI4 1
LSHI4
LEI4 $222
line 377
;377:                    trap_SendServerCommand( -1, "print \"Vote passed. At least 2 of 3 voted yes\n\"" );
CNSTI4 -1
ARGI4
ADDRGP4 $226
ARGP4
ADDRGP4 trap_SendServerCommand
CALLV
pop
line 378
;378:                    level.voteExecuteTime = level.time + 3000;
ADDRGP4 level+2408
ADDRGP4 level+32
INDIRI4
CNSTI4 3000
ADDI4
ASGNI4
line 379
;379:                } else {
ADDRGP4 $216
JUMPV
LABELV $222
line 381
;380:                    //Let pass if there is more yes than no and at least 2 yes votes and at least 30% yes of all on the server
;381:                    if ( level.voteYes > level.voteNo && level.voteYes >= 2 && (level.voteYes*10)>(level.numVotingClients*3) ) {
ADDRGP4 level+2412
INDIRI4
ADDRGP4 level+2416
INDIRI4
LEI4 $229
ADDRGP4 level+2412
INDIRI4
CNSTI4 2
LTI4 $229
CNSTI4 10
ADDRGP4 level+2412
INDIRI4
MULI4
CNSTI4 3
ADDRGP4 level+2420
INDIRI4
MULI4
LEI4 $229
line 382
;382:                        trap_SendServerCommand( -1, "print \"Vote passed. More yes than no.\n\"" );
CNSTI4 -1
ARGI4
ADDRGP4 $236
ARGP4
ADDRGP4 trap_SendServerCommand
CALLV
pop
line 383
;383:                        level.voteExecuteTime = level.time + 3000;
ADDRGP4 level+2408
ADDRGP4 level+32
INDIRI4
CNSTI4 3000
ADDI4
ASGNI4
line 384
;384:                    } else
ADDRGP4 $216
JUMPV
LABELV $229
line 385
;385:                        trap_SendServerCommand( -1, "print \"Vote failed.\n\"" );
CNSTI4 -1
ARGI4
ADDRGP4 $239
ARGP4
ADDRGP4 trap_SendServerCommand
CALLV
pop
line 386
;386:                }
line 387
;387:            } else {
ADDRGP4 $216
JUMPV
LABELV $219
line 388
;388:                trap_SendServerCommand( -1, "print \"Vote failed.\n\"" );
CNSTI4 -1
ARGI4
ADDRGP4 $239
ARGP4
ADDRGP4 trap_SendServerCommand
CALLV
pop
line 389
;389:            }
line 390
;390:	} else {
ADDRGP4 $216
JUMPV
LABELV $215
line 392
;391:		// ATVI Q3 1.32 Patch #9, WNF
;392:		if ( level.voteYes > (level.numVotingClients)/2 ) {
ADDRGP4 level+2412
INDIRI4
ADDRGP4 level+2420
INDIRI4
CNSTI4 2
DIVI4
LEI4 $240
line 394
;393:			// execute the command, then remove the vote
;394:			trap_SendServerCommand( -1, "print \"Vote passed.\n\"" );
CNSTI4 -1
ARGI4
ADDRGP4 $244
ARGP4
ADDRGP4 trap_SendServerCommand
CALLV
pop
line 395
;395:			level.voteExecuteTime = level.time + 3000;
ADDRGP4 level+2408
ADDRGP4 level+32
INDIRI4
CNSTI4 3000
ADDI4
ASGNI4
line 396
;396:		} else if ( level.voteNo >= (level.numVotingClients)/2 ) {
ADDRGP4 $241
JUMPV
LABELV $240
ADDRGP4 level+2416
INDIRI4
ADDRGP4 level+2420
INDIRI4
CNSTI4 2
DIVI4
LTI4 $203
line 398
;397:			// same behavior as a timeout
;398:			trap_SendServerCommand( -1, "print \"Vote failed.\n\"" );
CNSTI4 -1
ARGI4
ADDRGP4 $239
ARGP4
ADDRGP4 trap_SendServerCommand
CALLV
pop
line 399
;399:		} else {
line 401
;400:			// still waiting for a majority
;401:			return;
LABELV $248
LABELV $241
line 403
;402:		}
;403:	}
LABELV $216
line 404
;404:	level.voteTime = 0;
ADDRGP4 level+2404
CNSTI4 0
ASGNI4
line 405
;405:	trap_SetConfigstring( CS_VOTE_TIME, "" );
CNSTI4 8
ARGI4
ADDRGP4 $252
ARGP4
ADDRGP4 trap_SetConfigstring
CALLV
pop
line 407
;406:
;407:}
LABELV $203
endproc CheckVote 4 8
export ForceFail
proc ForceFail 0 8
line 409
;408:
;409:void ForceFail( void ) {
line 410
;410:    level.voteTime = 0;
ADDRGP4 level+2404
CNSTI4 0
ASGNI4
line 411
;411:    level.voteExecuteTime = 0;
ADDRGP4 level+2408
CNSTI4 0
ASGNI4
line 412
;412:    level.voteString[0] = 0;
ADDRGP4 level+356
CNSTI1 0
ASGNI1
line 413
;413:    level.voteDisplayString[0] = 0;
ADDRGP4 level+1380
CNSTI1 0
ASGNI1
line 414
;414:    level.voteKickClient = -1;
ADDRGP4 level+2424
CNSTI4 -1
ASGNI4
line 415
;415:    level.voteKickType = 0;
ADDRGP4 level+2428
CNSTI4 0
ASGNI4
line 416
;416:    trap_SetConfigstring( CS_VOTE_TIME, "" );
CNSTI4 8
ARGI4
ADDRGP4 $252
ARGP4
ADDRGP4 trap_SetConfigstring
CALLV
pop
line 417
;417:    trap_SetConfigstring( CS_VOTE_STRING, "" );	
CNSTI4 9
ARGI4
ADDRGP4 $252
ARGP4
ADDRGP4 trap_SetConfigstring
CALLV
pop
line 418
;418:    trap_SetConfigstring( CS_VOTE_YES, "" );
CNSTI4 10
ARGI4
ADDRGP4 $252
ARGP4
ADDRGP4 trap_SetConfigstring
CALLV
pop
line 419
;419:    trap_SetConfigstring( CS_VOTE_NO, "" );
CNSTI4 11
ARGI4
ADDRGP4 $252
ARGP4
ADDRGP4 trap_SetConfigstring
CALLV
pop
line 420
;420:}
LABELV $253
endproc ForceFail 0 8
export CountVotes
proc CountVotes 16 8
line 430
;421:
;422:
;423:/*
;424:==================
;425:CountVotes
;426:
;427: Iterates through all the clients and counts the votes
;428:==================
;429:*/
;430:void CountVotes( void ) {
line 432
;431:    int i;
;432:    int yes=0,no=0;
ADDRLP4 4
CNSTI4 0
ASGNI4
ADDRLP4 8
CNSTI4 0
ASGNI4
line 434
;433:
;434:    level.numVotingClients=0;
ADDRGP4 level+2420
CNSTI4 0
ASGNI4
line 436
;435:
;436:    for ( i = 0 ; i < level.maxclients ; i++ ) {
ADDRLP4 0
CNSTI4 0
ASGNI4
ADDRGP4 $265
JUMPV
LABELV $262
line 437
;437:            if ( level.clients[ i ].pers.connected != CON_CONNECTED )
CNSTI4 2116
ADDRLP4 0
INDIRI4
MULI4
ADDRGP4 level
INDIRP4
ADDP4
CNSTI4 468
ADDP4
INDIRI4
CNSTI4 2
EQI4 $267
line 438
;438:                continue; //Client was not connected
ADDRGP4 $263
JUMPV
LABELV $267
line 440
;439:
;440:            if (level.clients[i].sess.sessionTeam == TEAM_SPECTATOR)
CNSTI4 2116
ADDRLP4 0
INDIRI4
MULI4
ADDRGP4 level
INDIRP4
ADDP4
CNSTI4 1024
ADDP4
INDIRI4
CNSTI4 3
NEI4 $269
line 441
;441:		continue; //Don't count spectators
ADDRGP4 $263
JUMPV
LABELV $269
line 443
;442:
;443:            if ( g_entities[i].r.svFlags & SVF_BOT )
CNSTI4 816
ADDRLP4 0
INDIRI4
MULI4
ADDRGP4 g_entities+208+216
ADDP4
INDIRI4
CNSTI4 8
BANDI4
CNSTI4 0
EQI4 $271
line 444
;444:                continue; //Is a bot
ADDRGP4 $263
JUMPV
LABELV $271
line 447
;445:
;446:            //The client can vote
;447:            level.numVotingClients++;
ADDRLP4 12
ADDRGP4 level+2420
ASGNP4
ADDRLP4 12
INDIRP4
ADDRLP4 12
INDIRP4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
line 450
;448:
;449:            //Did the client vote yes?
;450:            if(level.clients[i].vote>0)
CNSTI4 2116
ADDRLP4 0
INDIRI4
MULI4
ADDRGP4 level
INDIRP4
ADDP4
CNSTI4 1252
ADDP4
INDIRI4
CNSTI4 0
LEI4 $276
line 451
;451:                yes++;
ADDRLP4 4
ADDRLP4 4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $276
line 454
;452:
;453:            //Did the client vote no?
;454:            if(level.clients[i].vote<0)
CNSTI4 2116
ADDRLP4 0
INDIRI4
MULI4
ADDRGP4 level
INDIRP4
ADDP4
CNSTI4 1252
ADDP4
INDIRI4
CNSTI4 0
GEI4 $278
line 455
;455:                no++;
ADDRLP4 8
ADDRLP4 8
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $278
line 456
;456:    }
LABELV $263
line 436
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $265
ADDRLP4 0
INDIRI4
ADDRGP4 level+24
INDIRI4
LTI4 $262
line 459
;457:
;458:    //See if anything has changed
;459:    if(level.voteYes != yes) {
ADDRGP4 level+2412
INDIRI4
ADDRLP4 4
INDIRI4
EQI4 $280
line 460
;460:        level.voteYes = yes;
ADDRGP4 level+2412
ADDRLP4 4
INDIRI4
ASGNI4
line 461
;461:        trap_SetConfigstring( CS_VOTE_YES, va("%i", level.voteYes ) );
ADDRGP4 $284
ARGP4
ADDRGP4 level+2412
INDIRI4
ARGI4
ADDRLP4 12
ADDRGP4 va
CALLP4
ASGNP4
CNSTI4 10
ARGI4
ADDRLP4 12
INDIRP4
ARGP4
ADDRGP4 trap_SetConfigstring
CALLV
pop
line 462
;462:    }
LABELV $280
line 464
;463:
;464:    if(level.voteNo != no) {
ADDRGP4 level+2416
INDIRI4
ADDRLP4 8
INDIRI4
EQI4 $286
line 465
;465:        level.voteNo = no;
ADDRGP4 level+2416
ADDRLP4 8
INDIRI4
ASGNI4
line 466
;466:        trap_SetConfigstring( CS_VOTE_NO, va("%i", level.voteNo ) );
ADDRGP4 $284
ARGP4
ADDRGP4 level+2416
INDIRI4
ARGI4
ADDRLP4 12
ADDRGP4 va
CALLP4
ASGNP4
CNSTI4 11
ARGI4
ADDRLP4 12
INDIRP4
ARGP4
ADDRGP4 trap_SetConfigstring
CALLV
pop
line 467
;467:    }
LABELV $286
line 468
;468:}
LABELV $260
endproc CountVotes 16 8
export ClientLeaving
proc ClientLeaving 0 0
line 470
;469:
;470:void ClientLeaving(int clientNumber) {
line 471
;471:    if(clientNumber == level.voteKickClient) {
ADDRFP4 0
INDIRI4
ADDRGP4 level+2424
INDIRI4
NEI4 $292
line 472
;472:            ForceFail();
ADDRGP4 ForceFail
CALLV
pop
line 473
;473:    }
LABELV $292
line 474
;474:}
LABELV $291
endproc ClientLeaving 0 0
import G_admin_namelog_cleanup
import G_admin_cleanup
import G_admin_duration
import G_admin_buffer_end
import G_admin_buffer_begin
import G_admin_buffer_print
import G_admin_print
import G_admin_shuffle
import G_admin_warn
import G_admin_slap
import G_admin_orient
import G_admin_disorient
import G_admin_unlock
import G_admin_lock
import G_admin_namelog
import G_admin_nextmap
import G_admin_restart
import G_admin_rename
import G_admin_spec999
import G_admin_passvote
import G_admin_cancelvote
import G_admin_allready
import G_admin_admintest
import G_admin_help
import G_admin_showbans
import G_admin_mute
import G_admin_map
import G_admin_listplayers
import G_admin_listadmins
import G_admin_putteam
import G_admin_unban
import G_admin_ban
import G_admin_adjustban
import G_admin_kick
import G_admin_setlevel
import G_admin_time
import G_admin_parse_time
import G_admin_level
import G_admin_namelog_update
import G_admin_name_check
import G_admin_permission
import G_admin_readconfig
import G_admin_cmd_check
import G_admin_ban_check
import G_ConfigClientExcellent
import G_checkForMultiKill
import G_CheckForSpree
import G_RunStreakLogic
import G_ReadAltKillSettings
import Svcmd_MessageWrapper
import Svcmd_ListIP_f
import Svcmd_Chat_f
import Svcmd_DumpUser_f
import Svcmd_EjectClient_f
import Svcmd_BannerPrint_f
import Svcmd_CenterPrint_f
import Svcmd_TeamMessage_f
import Svcmd_Status_f
import trap_DemoCommand
import trap_SnapVector
import trap_GeneticParentsAndChildSelection
import trap_BotResetWeaponState
import trap_BotFreeWeaponState
import trap_BotAllocWeaponState
import trap_BotLoadWeaponWeights
import trap_BotGetWeaponInfo
import trap_BotChooseBestFightWeapon
import trap_BotAddAvoidSpot
import trap_BotInitMoveState
import trap_BotFreeMoveState
import trap_BotAllocMoveState
import trap_BotPredictVisiblePosition
import trap_BotMovementViewTarget
import trap_BotReachabilityArea
import trap_BotResetLastAvoidReach
import trap_BotResetAvoidReach
import trap_BotMoveInDirection
import trap_BotMoveToGoal
import trap_BotResetMoveState
import trap_BotFreeGoalState
import trap_BotAllocGoalState
import trap_BotMutateGoalFuzzyLogic
import trap_BotSaveGoalFuzzyLogic
import trap_BotInterbreedGoalFuzzyLogic
import trap_BotFreeItemWeights
import trap_BotLoadItemWeights
import trap_BotUpdateEntityItems
import trap_BotInitLevelItems
import trap_BotSetAvoidGoalTime
import trap_BotAvoidGoalTime
import trap_BotGetLevelItemGoal
import trap_BotGetMapLocationGoal
import trap_BotGetNextCampSpotGoal
import trap_BotItemGoalInVisButNotVisible
import trap_BotTouchingGoal
import trap_BotChooseNBGItem
import trap_BotChooseLTGItem
import trap_BotGetSecondGoal
import trap_BotGetTopGoal
import trap_BotGoalName
import trap_BotDumpGoalStack
import trap_BotDumpAvoidGoals
import trap_BotEmptyGoalStack
import trap_BotPopGoal
import trap_BotPushGoal
import trap_BotResetAvoidGoals
import trap_BotRemoveFromAvoidGoals
import trap_BotResetGoalState
import trap_BotSetChatName
import trap_BotSetChatGender
import trap_BotLoadChatFile
import trap_BotReplaceSynonyms
import trap_UnifyWhiteSpaces
import trap_BotMatchVariable
import trap_BotFindMatch
import trap_StringContains
import trap_BotGetChatMessage
import trap_BotEnterChat
import trap_BotChatLength
import trap_BotReplyChat
import trap_BotNumInitialChats
import trap_BotInitialChat
import trap_BotNumConsoleMessages
import trap_BotNextConsoleMessage
import trap_BotRemoveConsoleMessage
import trap_BotQueueConsoleMessage
import trap_BotFreeChatState
import trap_BotAllocChatState
import trap_Characteristic_String
import trap_Characteristic_BInteger
import trap_Characteristic_Integer
import trap_Characteristic_BFloat
import trap_Characteristic_Float
import trap_BotFreeCharacter
import trap_BotLoadCharacter
import trap_EA_ResetInput
import trap_EA_GetInput
import trap_EA_EndRegular
import trap_EA_View
import trap_EA_Move
import trap_EA_DelayedJump
import trap_EA_Jump
import trap_EA_SelectWeapon
import trap_EA_MoveRight
import trap_EA_MoveLeft
import trap_EA_MoveBack
import trap_EA_MoveForward
import trap_EA_MoveDown
import trap_EA_MoveUp
import trap_EA_Crouch
import trap_EA_Respawn
import trap_EA_Use
import trap_EA_Attack
import trap_EA_Talk
import trap_EA_Gesture
import trap_EA_Action
import trap_EA_Command
import trap_EA_SayTeam
import trap_EA_Say
import trap_AAS_PredictClientMovement
import trap_AAS_Swimming
import trap_AAS_AlternativeRouteGoals
import trap_AAS_PredictRoute
import trap_AAS_EnableRoutingArea
import trap_AAS_AreaTravelTimeToGoalArea
import trap_AAS_AreaReachability
import trap_AAS_IntForBSPEpairKey
import trap_AAS_FloatForBSPEpairKey
import trap_AAS_VectorForBSPEpairKey
import trap_AAS_ValueForBSPEpairKey
import trap_AAS_NextBSPEntity
import trap_AAS_PointContents
import trap_AAS_TraceAreas
import trap_AAS_PointReachabilityAreaIndex
import trap_AAS_PointAreaNum
import trap_AAS_Time
import trap_AAS_PresenceTypeBoundingBox
import trap_AAS_Initialized
import trap_AAS_EntityInfo
import trap_AAS_AreaInfo
import trap_AAS_BBoxAreas
import trap_BotUserCommand
import trap_BotGetServerCommand
import trap_BotGetSnapshotEntity
import trap_BotLibTest
import trap_BotLibUpdateEntity
import trap_BotLibLoadMap
import trap_BotLibStartFrame
import trap_BotLibDefine
import trap_BotLibVarGet
import trap_BotLibVarSet
import trap_BotLibShutdown
import trap_BotLibSetup
import trap_DebugPolygonDelete
import trap_DebugPolygonCreate
import trap_GetEntityToken
import trap_GetUsercmd
import trap_BotFreeClient
import trap_BotAllocateClient
import trap_EntityContact
import trap_EntitiesInBox
import trap_UnlinkEntity
import trap_LinkEntity
import trap_AreasConnected
import trap_AdjustAreaPortalState
import trap_InPVSIgnorePortals
import trap_InPVS
import trap_PointContents
import trap_Trace
import trap_SetBrushModel
import trap_GetServerinfo
import trap_SetUserinfo
import trap_GetUserinfo
import trap_GetConfigstring
import trap_SetConfigstring
import trap_SendServerCommand
import trap_DropClient
import trap_LocateGameData
import trap_Cvar_VariableStringBuffer
import trap_Cvar_VariableValue
import trap_Cvar_VariableIntegerValue
import trap_Cvar_Set
import trap_Cvar_Update
import trap_Cvar_Register
import trap_SendConsoleCommand
import trap_FS_Seek
import trap_FS_GetFileList
import trap_FS_FCloseFile
import trap_FS_Write
import trap_FS_Read
import trap_FS_FOpenFile
import trap_Args
import trap_Argv
import trap_Argc
import trap_RealTime
import trap_Milliseconds
import trap_Error
import trap_Printf
import g_maxNameChanges
import g_minNameChangePeriod
import g_warningExpire
import g_maxWarnings
import g_publicAdminMessages
import g_specChat
import g_adminMaxBan
import g_adminTempBan
import g_adminNameProtect
import g_adminParseSay
import g_adminLog
import g_admin
import g_floodMinTime
import g_floodMaxDemerits
import g_spreeDiv
import g_altExcellent
import g_sprees
import g_lagLightning
import sv_fps
import g_truePing
import g_delagHitscan
import g_blueTeamClientNumbers
import g_redTeamClientNumbers
import g_humanplayers
import g_maxvotes
import g_voteMaxFraglimit
import g_voteMinFraglimit
import g_voteMaxTimelimit
import g_voteMinTimelimit
import g_voteGametypes
import g_voteBan
import g_voteNames
import g_mappools
import g_autonextmap
import g_catchup
import g_persistantpowerups
import g_awardpushing
import g_elimination_ctf_oneway
import g_lms_mode
import g_lms_lives
import g_ffa_gt
import g_regen
import g_vampireMaxHealth
import g_vampire
import g_instantgib
import g_rockets
import g_elimination_lockspectator
import g_elimination_nail
import g_elimination_mine
import g_elimination_chain
import g_elimination_plasmagun
import g_elimination_lightning
import g_elimination_railgun
import g_elimination_rocket
import g_elimination_grenade
import g_elimination_shotgun
import g_elimination_machinegun
import g_elimination_allgametypes
import g_elimination_activewarmup
import g_elimination_warmup
import g_elimination_roundtime
import g_elimination_grapple
import g_elimination_bfg
import g_elimination_startArmor
import g_elimination_startHealth
import g_elimination_selfdamage
import g_spawnprotect
import g_music
import g_proxMineTimeout
import g_enableBreath
import g_enableDust
import g_rankings
import pmove_float
import pmove_msec
import pmove_fixed
import g_smoothClients
import g_cubeTimeout
import g_obeliskRespawnDelay
import g_obeliskRegenAmount
import g_obeliskRegenPeriod
import g_obeliskHealth
import g_filterBan
import g_banIPs
import g_teamForceBalance
import g_teamAutoJoin
import g_allowVote
import g_blood
import g_doWarmup
import g_warmup
import g_votecustom
import g_votemaps
import g_motdfile
import g_motd
import g_synchronousClients
import g_weaponTeamRespawn
import g_weaponRespawn
import g_debugDamage
import g_debugAlloc
import g_debugMove
import g_inactivity
import g_respawntime
import g_forcerespawn
import g_quadfactor
import g_knockback
import g_speed
import g_gravityModifier
import g_gravity
import g_needpass
import g_password
import g_friendlyFire
import g_capturelimit
import g_timelimit
import g_fraglimit
import g_voteflags
import g_elimflags
import g_videoflags
import g_dmflags
import g_restarted
import g_maxGameClients
import g_maxclients
import g_cheats
import g_dedicated
import g_gametype
import g_entities
import level
import Team_ForceGesture
import Team_DD_bonusAtPoints
import Team_RemoveDoubleDominationPoints
import Team_SpawnDoubleDominationPoints
import Pickup_Team
import CheckTeamStatus
import TeamplayInfoMessage
import Team_GetLocationMsg
import Team_GetLocation
import Team_Dom_SpawnPoints
import SelectDoubleDominationSpawnPoint
import SelectCTFSpawnPoint
import Team_FreeEntity
import Team_ReturnFlag
import Team_InitGame
import Team_CheckHurtCarrier
import Team_FragBonuses
import Team_DroppedFlagThink
import AddTeamScore
import TeamColorString
import OtherTeamName
import TeamName
import OtherTeam
import BotTestAAS
import BotAIStartFrame
import BotAIShutdownClient
import BotAISetupClient
import BotAILoadMap
import BotAIShutdown
import BotAISetup
bss
export custom_vote_info
align 1
LABELV custom_vote_info
skip 1024
import PlayerStore_restore
import PlayerStore_store
import PlayerStoreInit
import BotInterbreedEndMatch
import Svcmd_BotList_f
import Svcmd_AddBot_f
import G_BotConnect
import G_RemoveQueuedBotBegin
import G_CheckBotSpawn
import G_GetBotInfoByName
import G_GetBotInfoByNumber
import G_InitBots
import Svcmd_AbortPodium_f
import SpawnModelsOnVictoryPads
import UpdateTournamentInfo
import G_WriteSessionData
import G_InitWorldSession
import G_InitSessionData
import G_ReadSessionData
import Svcmd_GameMem_f
import G_TeamFromString
import ShuffleTeams
import CheckObeliskAttack
import Team_CheckDroppedItem
import OnSameTeam
import G_RunClient
import ClientEndFrame
import ClientThink
import ClientCommand
import ClientBegin
import ClientDisconnect
import ClientUserinfoChanged
import ClientConnect
import CheckTeamVote
import LogExit
import G_DemoCommand
import G_Error
import G_Printf
import SendYourTeamMessageToTeam
import SendDominationPointsStatusMessageToAllClients
import SendDDtimetakenMessageToAllClients
import SendEliminationMessageToAllClients
import SendScoreboardMessageToAllClients
import G_LogPrintf
import ExitLevel
import AddTournamentQueue
import G_RunThink
import CheckTeamLeader
import SetLeader
import FindIntermissionPoint
import SendCustomVoteCommands
import ChallengeMessage
import DominationPointStatusMessage
import DominationPointNamesMessage
import RespawnTimeMessage
import EliminationMessage
import DeathmatchScoreboardMessage
import ObeliskHealthMessage
import AttackingTeamMessage
import YourTeamMessage
import DoubleDominationScoreTimeMessage
import G_SetStats
import MoveClientToIntermission
import G_StartKamikaze
import FireWeapon
import ClientForString
import G_FilterPacket
import G_ProcessIPBans
import ConsoleCommand
import SpotWouldTelefrag
import CalculateRanks
import AddScore
import player_die
import ClientSpawn
import InitBodyQue
import InitClientResp
import InitClientPersistant
import BeginIntermission
import respawn
import CopyToBodyQue
import SelectSpawnPoint
import SetClientViewAngle
import PickTeam
import TeamLeader
import LMSpoint
import EndEliminationRound
import DisableWeapons
import EnableWeapons
import RespawnDead
import RespawnAll
import TeamHealthCount
import TeamLivingCount
import TeamCount
import G_PredictPlayerMove
import G_UnTimeShiftClient
import G_UndoTimeShiftFor
import G_DoTimeShiftFor
import G_UnTimeShiftAllClients
import G_TimeShiftAllClients
import G_StoreHistory
import G_ResetHistory
import Weapon_HookThink
import Weapon_HookFree
import CheckGauntletAttack
import SnapVectorTowards
import CalcMuzzlePoint
import LogAccuracyHit
import DropPortalDestination
import DropPortalSource
import TeleportPlayer
import trigger_teleporter_touch
import Touch_DoorTrigger
import G_RunMover
import fire_prox
import fire_nail
import fire_grapple
import fire_bfg
import fire_rocket
import fire_grenade
import fire_plasma
import fire_blaster
import ProximityMine_RemoveAll
import G_RunMissile
import TossClientCubes
import TossClientPersistantPowerups
import TossClientItems
import body_die
import G_InvulnerabilityEffect
import G_RadiusDamage
import G_Damage
import CanDamage
import BuildShaderStateConfig
import AddRemap
import G_SetOrigin
import G_AddEvent
import G_AddPredictableEvent
import vectoyaw
import vtos
import tv
import G_TouchSolids
import G_TouchTriggers
import G_EntitiesFree
import G_FreeEntity
import G_GlobalSound
import G_Sound
import G_TempEntity
import G_Spawn
import G_InitGentity
import G_SetMovedir
import G_UseTargets
import G_PickTarget
import G_Find
import G_KillBox
import G_TeamCommand
import G_SoundIndex
import G_ModelIndex
import SaveRegisteredItems
import RegisterItem
import ClearRegisteredItems
import Touch_Item
import Add_Ammo
import ArmorIndex
import Think_Weapon
import FinishSpawningItem
import G_SpawnItem
import SetRespawn
import LaunchItem
import Drop_Item
import PrecacheItem
import UseHoldableItem
import RespawnItem
import G_RunItem
import G_CheckTeamItems
import writeFile_string
import writeFile_int
import readFile_string
import readFile_int
import SanitizeString
import G_ClientIsLagging
import G_ClientNumberFromString
import Cmd_AdminMessage_f
import G_FloodLimited
import G_ClientNumbersFromString
import G_SanitiseString
import G_MatchOnePlayer
import G_DecolorString
import G_SayConcatArgs
import G_SayArgv
import G_SayArgc
import G_Say
import ConcatArgs
import Cmd_FollowCycle_f
import SetTeam
import BroadcastTeamChange
import StopFollowing
import Cmd_Score_f
import G_NewString
import G_SpawnEntitiesFromString
import G_SpawnVector
import G_SpawnInt
import G_SpawnFloat
import G_SpawnString
import BG_TeamName
import BG_PlayerTouchesItem
import BG_PlayerStateToEntityStateExtraPolate
import BG_PlayerStateToEntityState
import BG_TouchJumpPad
import BG_AddPredictableEventToPlayerstate
import BG_EvaluateTrajectoryDelta
import BG_EvaluateTrajectory
import BG_DefragmentMemory
import BG_Free
import BG_InitMemory
import BG_Alloc
import BG_CanAlloc
import BG_CanItemBeGrabbed
import BG_FindItemForHoldable
import BG_FindItemForPowerup
import BG_FindItemForWeapon
import BG_FindItem
import bg_numItems
import bg_itemlist
import Pmove
import PM_UpdateViewAngles
import Com_Printf
import Com_Error
import Info_NextPair
import Info_Validate
import Info_SetValueForKey_Big
import Info_SetValueForKey
import Info_RemoveKey_big
import Info_RemoveKey
import Info_ValueForKey
import Com_TruncateLongString
import va
import Q_CountChar
import Q_CleanStr
import Q_PrintStrlen
import Q_strcat
import Q_strncpyz
import Q_stristr
import Q_strupr
import Q_strlwr
import Q_stricmpn
import Q_strncmp
import Q_stricmp
import Q_isalpha
import Q_isupper
import Q_islower
import Q_isprint
import Com_RandomBytes
import Com_SkipCharset
import Com_SkipTokens
import Com_sprintf
import Parse3DMatrix
import Parse2DMatrix
import Parse1DMatrix
import SkipRestOfLine
import SkipBracedSection
import COM_MatchToken
import COM_ParseWarning
import COM_ParseError
import COM_Compress
import COM_ParseExt
import COM_Parse
import COM_GetCurrentParseLine
import COM_BeginParseSession
import COM_DefaultExtension
import COM_StripExtension
import COM_GetExtension
import COM_SkipPath
import Com_Clamp
import Q_isnan
import PerpendicularVector
import AngleVectors
import MatrixMultiply
import MakeNormalVectors
import RotateAroundDirection
import RotatePointAroundVector
import ProjectPointOnPlane
import PlaneFromPoints
import AngleDelta
import AngleNormalize180
import AngleNormalize360
import AnglesSubtract
import AngleSubtract
import LerpAngle
import AngleMod
import BoundsIntersectPoint
import BoundsIntersectSphere
import BoundsIntersect
import BoxOnPlaneSide
import SetPlaneSignbits
import AxisCopy
import AxisClear
import AnglesToAxis
import vectoangles
import Q_crandom
import Q_random
import Q_rand
import Q_acos
import Q_log2
import VectorRotate
import Vector4Scale
import VectorNormalize2
import VectorNormalize
import CrossProduct
import VectorInverse
import VectorNormalizeFast
import DistanceSquared
import Distance
import VectorLengthSquared
import VectorLength
import VectorCompare
import AddPointToBounds
import ClearBounds
import RadiusFromBounds
import NormalizeColor
import ColorBytes4
import ColorBytes3
import _VectorMA
import _VectorScale
import _VectorCopy
import _VectorAdd
import _VectorSubtract
import _DotProduct
import ByteToDir
import DirToByte
import ClampShort
import ClampChar
import Q_rsqrt
import Q_fabs
import axisDefault
import vec3_origin
import g_color_table
import colorDkGrey
import colorMdGrey
import colorLtGrey
import colorWhite
import colorCyan
import colorMagenta
import colorYellow
import colorBlue
import colorGreen
import colorRed
import colorBlack
import bytedirs
import Hunk_Alloc
import FloatSwap
import LongSwap
import ShortSwap
import acos
import fabs
import abs
import tan
import atan2
import cos
import sin
import sqrt
import floor
import ceil
import memcpy
import memset
import memmove
import sscanf
import Q_snprintf
import Q_vsnprintf
import strtol
import _atoi
import atoi
import strtod
import _atof
import atof
import toupper
import tolower
import strncpy
import strstr
import strrchr
import strchr
import strcmp
import strcpy
import strcat
import strlen
import rand
import srand
import qsort
lit
align 1
LABELV $284
byte 1 37
byte 1 105
byte 1 0
align 1
LABELV $252
byte 1 0
align 1
LABELV $244
byte 1 112
byte 1 114
byte 1 105
byte 1 110
byte 1 116
byte 1 32
byte 1 34
byte 1 86
byte 1 111
byte 1 116
byte 1 101
byte 1 32
byte 1 112
byte 1 97
byte 1 115
byte 1 115
byte 1 101
byte 1 100
byte 1 46
byte 1 10
byte 1 34
byte 1 0
align 1
LABELV $239
byte 1 112
byte 1 114
byte 1 105
byte 1 110
byte 1 116
byte 1 32
byte 1 34
byte 1 86
byte 1 111
byte 1 116
byte 1 101
byte 1 32
byte 1 102
byte 1 97
byte 1 105
byte 1 108
byte 1 101
byte 1 100
byte 1 46
byte 1 10
byte 1 34
byte 1 0
align 1
LABELV $236
byte 1 112
byte 1 114
byte 1 105
byte 1 110
byte 1 116
byte 1 32
byte 1 34
byte 1 86
byte 1 111
byte 1 116
byte 1 101
byte 1 32
byte 1 112
byte 1 97
byte 1 115
byte 1 115
byte 1 101
byte 1 100
byte 1 46
byte 1 32
byte 1 77
byte 1 111
byte 1 114
byte 1 101
byte 1 32
byte 1 121
byte 1 101
byte 1 115
byte 1 32
byte 1 116
byte 1 104
byte 1 97
byte 1 110
byte 1 32
byte 1 110
byte 1 111
byte 1 46
byte 1 10
byte 1 34
byte 1 0
align 1
LABELV $226
byte 1 112
byte 1 114
byte 1 105
byte 1 110
byte 1 116
byte 1 32
byte 1 34
byte 1 86
byte 1 111
byte 1 116
byte 1 101
byte 1 32
byte 1 112
byte 1 97
byte 1 115
byte 1 115
byte 1 101
byte 1 100
byte 1 46
byte 1 32
byte 1 65
byte 1 116
byte 1 32
byte 1 108
byte 1 101
byte 1 97
byte 1 115
byte 1 116
byte 1 32
byte 1 50
byte 1 32
byte 1 111
byte 1 102
byte 1 32
byte 1 51
byte 1 32
byte 1 118
byte 1 111
byte 1 116
byte 1 101
byte 1 100
byte 1 32
byte 1 121
byte 1 101
byte 1 115
byte 1 10
byte 1 34
byte 1 0
align 1
LABELV $210
byte 1 37
byte 1 115
byte 1 10
byte 1 0
align 1
LABELV $200
byte 1 85
byte 1 110
byte 1 107
byte 1 110
byte 1 111
byte 1 119
byte 1 110
byte 1 32
byte 1 107
byte 1 101
byte 1 121
byte 1 32
byte 1 105
byte 1 110
byte 1 32
byte 1 99
byte 1 117
byte 1 115
byte 1 116
byte 1 111
byte 1 109
byte 1 118
byte 1 111
byte 1 116
byte 1 101
byte 1 46
byte 1 99
byte 1 102
byte 1 103
byte 1 58
byte 1 32
byte 1 37
byte 1 115
byte 1 10
byte 1 0
align 1
LABELV $197
byte 1 99
byte 1 111
byte 1 109
byte 1 109
byte 1 97
byte 1 110
byte 1 100
byte 1 0
align 1
LABELV $192
byte 1 100
byte 1 105
byte 1 115
byte 1 112
byte 1 108
byte 1 97
byte 1 121
byte 1 110
byte 1 97
byte 1 109
byte 1 101
byte 1 0
align 1
LABELV $187
byte 1 73
byte 1 110
byte 1 118
byte 1 97
byte 1 108
byte 1 105
byte 1 100
byte 1 47
byte 1 109
byte 1 105
byte 1 115
byte 1 115
byte 1 105
byte 1 110
byte 1 103
byte 1 32
byte 1 97
byte 1 114
byte 1 103
byte 1 117
byte 1 109
byte 1 101
byte 1 110
byte 1 116
byte 1 32
byte 1 116
byte 1 111
byte 1 32
byte 1 37
byte 1 115
byte 1 32
byte 1 105
byte 1 110
byte 1 32
byte 1 99
byte 1 117
byte 1 115
byte 1 116
byte 1 111
byte 1 109
byte 1 118
byte 1 111
byte 1 116
byte 1 101
byte 1 46
byte 1 99
byte 1 102
byte 1 103
byte 1 10
byte 1 0
align 1
LABELV $184
byte 1 125
byte 1 0
align 1
LABELV $181
byte 1 85
byte 1 110
byte 1 101
byte 1 120
byte 1 112
byte 1 101
byte 1 99
byte 1 116
byte 1 101
byte 1 100
byte 1 32
byte 1 101
byte 1 110
byte 1 100
byte 1 32
byte 1 111
byte 1 102
byte 1 32
byte 1 99
byte 1 117
byte 1 115
byte 1 116
byte 1 111
byte 1 109
byte 1 118
byte 1 111
byte 1 116
byte 1 101
byte 1 46
byte 1 99
byte 1 102
byte 1 103
byte 1 10
byte 1 0
align 1
LABELV $175
byte 1 77
byte 1 105
byte 1 115
byte 1 115
byte 1 105
byte 1 110
byte 1 103
byte 1 32
byte 1 123
byte 1 32
byte 1 105
byte 1 110
byte 1 32
byte 1 118
byte 1 111
byte 1 116
byte 1 101
byte 1 99
byte 1 117
byte 1 115
byte 1 116
byte 1 111
byte 1 109
byte 1 46
byte 1 99
byte 1 102
byte 1 103
byte 1 10
byte 1 0
align 1
LABELV $174
byte 1 123
byte 1 0
align 1
LABELV $161
byte 1 37
byte 1 115
byte 1 32
byte 1 0
align 1
LABELV $160
byte 1 118
byte 1 111
byte 1 116
byte 1 101
byte 1 99
byte 1 111
byte 1 109
byte 1 109
byte 1 97
byte 1 110
byte 1 100
byte 1 0
align 1
LABELV $121
byte 1 103
byte 1 95
byte 1 118
byte 1 111
byte 1 116
byte 1 101
byte 1 71
byte 1 97
byte 1 109
byte 1 101
byte 1 116
byte 1 121
byte 1 112
byte 1 101
byte 1 115
byte 1 0
align 1
LABELV $106
byte 1 109
byte 1 97
byte 1 112
byte 1 115
byte 1 47
byte 1 37
byte 1 115
byte 1 46
byte 1 98
byte 1 115
byte 1 112
byte 1 0
align 1
LABELV $95
byte 1 46
byte 1 98
byte 1 115
byte 1 112
byte 1 0
align 1
LABELV $94
byte 1 109
byte 1 97
byte 1 112
byte 1 115
byte 1 0
align 1
LABELV $66
byte 1 42
byte 1 0
align 1
LABELV $63
byte 1 103
byte 1 95
byte 1 118
byte 1 111
byte 1 116
byte 1 101
byte 1 78
byte 1 97
byte 1 109
byte 1 101
byte 1 115
byte 1 0
